* Program Name: icu.prg
* Author: Pat Y. Boens
* Copyright (c) 1994 by S.W.I.M
*Ŀ
* Created: 15 Jul 1994 at 11:37                                        
*                                                                      
* .................................................................... 
* Revision number : 1.0 Last Revised :7/15/1994 at 9:58                
* Description: Original Creation.                                      
* .................................................................... 
*                                                                      
*                       Ŀ                     
*Ĵ S.W.I.M and Pat Boens  
*                            rights reserved     
*                        

#define IN_PROGRAM              PROGRAM() + " ... in on "  + DTOC( DATE() ) + " at " + TIME()
#define OUT_PROGRAM             PROGRAM() + " ... out on " + DTOC( DATE() ) + " at " + TIME()

#define K_ESC                   27

#define PAVE                    1
#define DALLE                   2

#define GRAY                    RGB( 128,128,128,128,128,128 )
#define LIGHT_GRAY              RGB( 192,192,192,192,192,192 )
#define GRAY_LIGHT              RGB( 128,128,128,192,192,192 )
#define WHITE                   RGB( 255,255,255,255,255,255 )
#define BLACK                   RGB( 0,0,0,0,0,0 )
#define BACKGROUND              RGB( ,,,192,192,192 )

#define MAXIMIZE                ZOOM
#define NOMAXIMIZE              NOZOOM
#define RESIZEABLE              GROW
#define NORESIZEABLE            NOGROW
#define MOVEABLE                FLOAT
#define NOMOVEABLE              NOFLOAT

#define ACTIVATE_EVENT          3
#define SIZE_EVENT              12

#define BROWSE_TITLE_CELL       1
#define ACTIVATE_WINDOW_CELL    2
#define INI_SECTION_CELL        3
#define ALIAS_CELL              4

EXTERNAL ARRAY aArrayEntry

FUNCTION SetupBrowses
    PRIVATE m.cBrowseEntries
    PRIVATE m.nBrowses
    PRIVATE m.i
    PRIVATE m.cOldSep

    m.cBrowseEntries = FIL_sectio( "BROWSES",VER_ini() )
    m.cOldSep        = STR_setsep( ";" )
    m.nBrowses       = STR_numtok( m.cBrowseEntries )

    DIMENSION gaBrowses[m.nBrowses,4]

    FOR m.i = 1 TO m.nBrowses
        gaBrowses[m.i,1] = STR_ntoken( m.i,m.cBrowseEntries )
        m.cBrowseDef     = FIL_reaini( "BROWSES",gaBrowses[m.i,1],VER_ini() )
        =STR_setsep( "," )
        gaBrowses[m.i,2] = STR_ntoken( 1,m.cBrowseDef )
        gaBrowses[m.i,3] = STR_ntoken( 2,m.cBrowseDef )
        gaBrowses[m.i,4] = STR_ntoken( 3,m.cBrowseDef )
        =STR_setsep( ";" )
    NEXT

    =STR_setsep( m.cOldSep )

RETURN ( .T. )

*----------------------------------------------------------------------*

FUNCTION StopRead
    PARAMETER m.window,m.lQuitting

    *-- Ŀ
    *--  PURPOSE : handles the DEACTIVATE clause of a READ.           
    *--            If it returns .F., the READ terminates.            
    *--            Otherwise the READ continues.                      
    *--                                                               
    *-- 

    IF ( ! WVISIBLE( m.window ) )      && Was window closed manually?
        m.lQuitting = .T.              && Act as if 'Quit' was pressed
    ENDIF

RETURN ( m.lQuitting .OR. ! WREAD() )  && Stop if 'quitting', or not a READ window

*----------------------------------------------------------------------*

FUNCTION StopRead2
    PARAMETER m.window,m.lQuitting,m.cWins

    *-- Ŀ
    *--  PURPOSE : handles the DEACTIVATE clause of a READ of an      
    *--            extended window.                                   
    *--            If it returns .F., the READ terminates.            
    *--            Otherwise the READ continues.                      
    *--                                                               
    *-- 

    IF ( ! WVISIBLE( m.window ) )      && Has window been closed manually?
        m.lQuitting = .T.              && Act as if 'Quit' was pressed
    ENDIF

    ?? CHR(7)

RETURN ( ! ( UPPER( WONTOP() ) $ m.cWins ) )

*----------------------------------------------------------------------*

PROCEDURE SetConf
    PARAMETER m.nBarNumber

    PRIVATE m.lConfirm

    *-- Ŀ
    *--  PURPOSE : sets the PUBLIC C variable to .T. or .F.           
    *--  (it's a switch)                                              
    *-- 

    m.lConfirm  = ! ( FIL_reaini( "EXIT","Confirmation",VER_ini() ) == "ON" )

    =FIL_wriini( "EXIT","Confirmation",IIF( m.lConfirm,"ON","OFF" ),VER_ini() ) )

    SET MARK OF BAR m.nBarNumber OF _pOptions TO m.lConfirm

RETURN

*----------------------------------------------------------------------*

FUNCTION AddDelWin
    PARAMETERS m.cWinTitle,m.cMode

    *-- Ŀ
    *--                                                               
    *--  PURPOSE: adds or deletes a window in a PUBLIC array. We need 
    *--           this array in order to keep track of all active     
    *--           windows during Run-Time                             
    *--                                                               
    *--  CAUTION: Should be reviewed !!!                              
    *--                                                               
    *-- 

*    PRIVATE m.nDim                     && Array dimension
*    PRIVATE m.nNewDim                  && New dimension
*    PRIVATE m.nPos                     && Position in array
*    PRIVATE m.i                        && Subscript
*
*    m.nDim = ALEN( aActiveWins )       && Number of elements
*
*    DO CASE
*        *-- Ŀ
*        *--  ADD a window to internal list.                           
*        *-- 
*        CASE ( cMode == "ADD" )        && Should we add a window
*
*            && If there is 1 active window minimum
*            IF ( aActiveWins[1] != "<none>" )
*
*                m.nNewDim = m.nDim + 1 && New array dimension
*                DIMENSION aActiveWins[m.nNewDim]
*                aActiveWins[m.nNewDim] = m.cWinTitle
*
*            ELSE                       && No window active so far
*
*                aActiveWins[1] = m.cWinTitle
*                m.nNewDim      = m.nDim
*
*            ENDIF
*
*        *-- Ŀ
*        *--  DELETE window from internal list.                        
*        *-- 
*        CASE ( cMode == "DEL" )        && Should we delete a window
*
*            m.nPos = ASCAN( aActiveWins,m.cWinTitle )
*
*            IF ( m.nPos != 0 )         && If we found this window in the array
*
*                IF ( m.nDim > 1 )      && More than 1 element ?
*
*                    && Delete given element
*                    =ADEL( aActiveWins,m.nPos )
*
*                    && Resize array
*                    m.nNewDim = m.nDim - 1
*                    DIMENSION aActiveWins[nNewDim]
*
*                ELSE                   && We didn't find this window in the array
*
*                    aActiveWins[1] = "<none>"
*                    m.nNewDim      = 1
*
*                ENDIF
*
*            ENDIF
*
*    ENDCASE
*
*    FOR m.i = 1 TO m.nDim
*        RELEASE BAR m.i OF _pWindows
*    NEXT
*
*    FOR m.i = 1 TO m.nNewDim
*        DEFINE BAR m.i OF _pWindows PROMPT aActiveWins[i]
*    NEXT

RETURN ( .T. )

*----------------------------------------------------------------------*

FUNCTION SaveAndKill
    PARAMETERS m.cWindow,m.cSection,m.cType,m.cTraceLog

    *-- Ŀ
    *--  PURPOSE : saves and then kill a window. Make sure tracing    
    *--            is also terminated.                                
    *-- 

    ACTIVATE WINDOW ( m.cWindow )
    =WIN_save( m.cWindow,m.cSection,VER_ini(),m.cType )

    =TRA_log( m.cTraceLog + " ... out on " + DTOC( DATE() ) + " at " + TIME() )

RETURN ( .T. )

*----------------------------------------------------------------------*

FUNCTION ConfirmExit
    PRIVATE m.lMustExit
    PRIVATE m.lConfirm
    PRIVATE m.nAction

    m.lMustExit = .T.                  && Must exit ? Default = Yes
    m.lConfirm  = ( FIL_reaini( "EXIT"        , ;
                                "Confirmation", ;
                                VER_ini()       ;
                              ) == "ON"         ;
                  )
    m.nAction   = 2                    && Cancel button by default

    IF ( m.lConfirm )                  && Exit confirmation ?
        =MIS_yesno( @m.nAction,"Voulez-vous quitter " + VER_name() + " ?","","" )
        m.lMustExit = ( m.nAction == 1 )
    ENDIF

RETURN ( m.lMustExit )

*----------------------------------------------------------------------*

FUNCTION SaveLastGet
    PARAMETER m.LastGet

    *-- Ŀ
    *--  PURPOSE : save the last GET object number !                  
    *-- 

    m.LastGet = _CUROBJ

RETURN ( .T. )

*----------------------------------------------------------------------*

PROCEDURE Rebuild
    *-- Ŀ
    *--  PURPOSE : rebuilds all application indexes.                  
    *--                                                               
    *--  WARNING : FIL_sectio() generates a GPF when it does not find 
    *--            the section                                        
    *-- 

    PRIVATE m.cEntries
    PRIVATE m.cOldSep
    PRIVATE m.i
    PRIVATE m.j
    PRIVATE m.nTokens
    PRIVATE m.cTags
    PRIVATE m.cDBF
    PRIVATE m.cIndexFile
    PRIVATE m.nTags
    PRIVATE m.cTagDef
    PRIVATE m.cTagName
    PRIVATE m.cTagKey
    PRIVATE m.cTagFilter
    PRIVATE m.cExternCode

    PRIVATE m.lIsActive
    PRIVATE m.OldArea

    m.lIsActive = EVE_isacti()         && Event handler active ?

    IF ( m.lIsActive )
        =EVE_end()                     && Stop Event handler
    ENDIF

    m.OldArea     = SELECT()           && Save old work area

    m.cExternCode = FIL_reaini( "INDEXES","ExternCode",VER_ini() )

	DEFINE WINDOW wTmp                  ;
		AT 09.000, 32.000               ;
        SIZE 10.40,55.500               ;
		TITLE DSK_title() + " Message"  ;
        FONT FNT_name(),FNT_size()      ;
		FLOAT                           ;
        NOCLOSE                         ;
        NOGROW                          ;
        NOZOOM                          ;
        NONE                            ;
        COLOR BACKGROUND

    ACTIVATE WINDOW wTmp  NOSHOW

    @ 00.00,00.00 SAY "stop4.bmp" BITMAP

    @ 01.00,18.00 SAY "Rindexation..." FONT FNT_name(),FNT_size() STYLE "B"
    @ 02.50,18.00 SAY "Attendre."       FONT FNT_name(),FNT_size() STYLE "B"

    MOVE WINDOW wTmp CENTER
    ACTIVATE WINDOW wTmp

    IF ( ! EMPTY( m.cExternCode ) )
        =DDA_filexe( m.cExternCode )
        RELEASE WINDOW wTmp
        RETU &&&&&&&&&&&&&&&&&&&&&&&&&& Immediate return
    ENDIF

    && The rest of the code does not perfectly work as expected !!!

    m.cEntries    = FIL_sectio( "INDEXES",VER_ini() )
    m.cOldSep     = STR_setsep( ";" )
    m.nTokens     = STR_numtok( m.cEntries )

    FOR m.i = 1 TO m.nTokens

        m.cIndexFile = STR_ntoken( m.i,m.cEntries )

        IF ( "EXTERNCODE" $ UPPER( m.cIndexFile ) )
            LOOP
        ENDIF

        m.cTags      = FIL_reaini( "INDEXES",m.cIndexFile,VER_ini() )
        m.nTags      = STR_numtok( m.cTags )
        m.cDBF       = STR_ntoken( 1,m.cTags )

        SELECT ( m.cDBF )              && Select appropriate work area

        FOR m.j = 2 TO m.nTags

            m.cTagDef    = STR_ntoken( m.j,m.cTags )

            =STR_setsep( "," )

            m.cTagName   = STR_ntoken( 1,m.cTagDef )
            m.cTagKey    = STR_ntoken( 2,m.cTagDef )
            m.cTagFilter = STR_ntoken( 3,m.cTagDef )

            =STR_setsep( ";" )

            IF ( EMPTY( m.cTagFilter ) )
                =DDA_execut( "INDEX ON "  + ;
                             m.cTagKey    + ;
                             " TAG "      + ;
                             m.cTagName   + ;
                             " ADDITIVE" )
            ELSE
                =DDA_execut( "INDEX ON "  + ;
                             m.cTagKey    + ;
                             " TAG "      + ;
                             m.cTagName   + ;
                             " FOR "      + ;
                             m.cTagFilter + ;
                             " ADDITIVE" )
            ENDIF

        NEXT

    NEXT

    RELEASE WINDOW wTmp

    =STR_setsep( m.cOldSep )

    SELECT ( m.OldArea )               && Restore old work area

    IF ( m.lIsActive )
        =EVE_start()                   && Restart Event handler
    ENDIF

RETURN

*----------------------------------------------------------------------*

PROCEDURE GetUser
    PRIVATE m.nAction
    PRIVATE m.cUserName
    PRIVATE m.cUserCie

    *-- Ŀ
    *--  PURPOSE : take 1st time ever the user name  
    *--                                              
    *-- 

    m.nAction   = 1
    m.cUserName = SPACE( 30 )
    m.cUserCie  = SPACE( 30 )

    DO WHILE ( EMPTY( m.cUserName ) )

        && Our own interface
        =TakeString( "Nom et socit",@m.cUserName,@m.cUserCie,@m.nAction )

        IF ( m.nAction == 2 )              && CANCEL button
            DO eoj WITH "ABORT"
        ENDIF

    ENDDO

    m.cUserName = ALLTRIM( m.cUserName )
    m.cUserCie  = ALLTRIM( m.cUserCie  )

    =FIL_wriini( "OWNER","Name"   ,STR_addcod( m.cUserName,17 ),VER_ini() )
    =USR_name( m.cUserName )
    =FIL_wriini( "OWNER","Company",STR_addcod( m.cUserCie ,17 ),VER_ini() )
    =USR_cmpany( m.cUserCie )

RETURN

*----------------------------------------------------------------------------*

FUNCTION TakeString
    PARAMETER m.cTitle,m.cData1,m.cData2,m.nAction

    *-- Ŀ
    *--  PURPOSE : gets a string from user. It is used for many       
    *--            instances : mail message, mail document, etc.      
    *-- 

    PRIVATE m.cWindow
    PRIVATE m.nAction
    PRIVATE m.nRow
    PRIVATE m.cBorderStatus

    PRIVATE aGets                      && 3D GETs array

    m.cBorderStatus = SET( "READBORDER" )

    SET READBORDER OFF
    m.nRow = 2

    IF ( LEN( cData2 ) > 0 )
        m.cWindow  = WIN_mdialg( 11.50,47.5,FNT_name(),FNT_size(),"",DALLE )

        DIMENSION aGets[2,4]

        aGets[2,1] = m.nRow + 1.5
        aGets[2,2] = 4
        aGets[2,3] = 1
        aGets[2,4] = 40

    ELSE
        m.cWindow  = WIN_mdialg( 10.00,47.5,FNT_name(),FNT_size(),"",DALLE )

        DIMENSION aGets[1,4]

    ENDIF

    aGets[1,1] = m.nRow
    aGets[1,2] = 4
    aGets[1,3] = 1
    aGets[1,4] = 40

    && Around the data entry
    =WIN_grave( 1  ,2,05        ,WCOLS() - 2 )

    && Around the buttons
    =WIN_grave( WROWS() - 4.7,2,WROWS() - 1,WCOLS() - 2 )

    @ 0.6,4 SAY m.cTitle STYLE "B"

    DO NiceGet WITH aGets,FNT_name(),FNT_size()

    @ m.nRow,04.00 GET m.cData1 ;
                   SIZE 1,40    ;
                   COLOR SCHEME 19

    IF ( LEN( cData2 ) > 0 )

        m.nRow = m.nRow + 1.5
        @ m.nRow,04.00 GET m.cData2 ;
                       SIZE 1,40    ;
                       COLOR SCHEME 19

    ENDIF

    m.nRow = m.nRow + 3.8

    @ m.nRow,04.00 GET m.nAction                      ;
                   PICTURE "@*BHT ok2.bmp;cancel.bmp" ;
                   SIZE 2.5,10,0.5

    READ MODAL                         && MODAL READ !!!!

    RELEASE WINDOW ( m.cWindow )

    SET READBORDER &cBorderStatus

RETURN ( .T. )

*----------------------------------------------------------------------------*

PROCEDURE About

    *-- Ŀ
    *--  PURPOSE : About box.                                         
    *-- 

    PRIVATE m.cWindow
    PRIVATE m.nCharHeight
    PRIVATE m.nCharWidth
    PRIVATE m.nButton
    PRIVATE m.cOldSep
    PRIVATE m.cBitmaps
    PRIVATE m.nTokens
    PRIVATE m.i
    PRIVATE m.cToken
    PRIVATE m.lIsActive
    PRIVATE m.cCustom
    PRIVATE m.cFiller

    =TRA_log( IN_PROGRAM )             && Tracing instruction

    m.lIsActive = EVE_isacti()         && Event handler active ?

    IF ( m.lIsActive )
       =EVE_end()
    ENDIF

    m.nButton  = 1                     && Default value

    && Create a window
    m.cWindow = WIN_mdialg( 25,64,FNT_name(),FNT_size(),"",PAVE )

    =WIN_grave( 1,2,WROWS() - 1,WCOLS() - 2 )
    =WIN_grave( 20,2,20,WCOLS() - 2 )

    m.cOldSep  = STR_setsep( ";" )
    m.cBitmaps = FIL_reaini( "ABOUT","Bitmap",VER_ini() )
    m.cFiller  = FIL_reaini( "ABOUT","Filler",VER_ini() )
    m.nTokens  = STR_numtok( m.cBitmaps )

    && Display filler file if one exists
    IF ( ! EMPTY( m.cFiller ) .AND. FILE( m.cFiller ) )
        MODIFY WINDOW ( m.cWindow ) FILL FILE &cFiller
    ENDIF

    && Display all bitmaps in About window

    FOR m.i = 1 TO m.nTokens

        m.cToken = STR_ntoken( i,m.cBitmaps )

        =STR_setsep( "," )

        @ VAL( STR_ntoken( 2,m.cToken ) ), ;
          VAL( STR_ntoken( 3,m.cToken ) )  ;
          SAY  STR_ntoken( 1,m.cToken ) BITMAP

        =STR_setsep( ";" )

    NEXT

    @ 02.00,14.50 SAY VER_name() + " - " + DSK_title() STYLE "BT"

    @ 03.50,14.50 SAY ALLTRIM( STR( VER_major() ) )                      + ;
                      "."                                                + ;
                      ALLTRIM( STR( VER_minor() ) )                      + ;
                      " - " + VER_cpyrig() STYLE "T"
    @ 05.00,14.5 SAY "Author : " + VER_author() STYLE "T"
    @ 06.50,14.5 SAY "User : " + USR_name() + " - " + USR_cmpany() STYLE "T"
    @ 08.00,14.5 SAY "Disk size : " + ALLTRIM( SYS( 2020 ) ) STYLE "T"
    @ 09.50,14.5 SAY "Processor : " + SYS( 17 )                          + ;
                     " Display : "  + SYS( 2006 ) STYLE "T"

    m.cCustom = FIL_reaini( "ABOUT","Custom",VER_ini() )

    IF ( ! EMPTY( m.cCustom ) )
       =DDA_execut( m.cCustom )
    ENDIF

    m.nCharHeight = FONTMETRIC( 1,FNT_name(),FNT_size() )
    m.nCharWidth  = FONTMETRIC( 6,FNT_name(),FNT_size() )

    m.nCol = ( ( WCOLS() * m.nCharWidth / 2 ) - ( 7 * m.nCharWidth ) ) / m.nCharWidth

    @ 20.8,m.nCol GET m.nButton               ;
                  PICTURE "@*BHT ok2.bmp"     ;
                  SIZE 3,14                   ;
                  FONT FNT_name(),FNT_size()

    ACTIVATE WINDOW ( m.cWindow )

    READ MODAL

    RELEASE WINDOW ( m.cWindow )

    =STR_setsep( m.cOldSep )

    IF ( m.lIsActive )
       =EVE_start()
    ENDIF

    =TRA_log( OUT_PROGRAM )            && Tracing instruction

RETURN

*----------------------------------------------------------------------*

FUNCTION WIN_mdialg
    PARAMETERS m.nHeight,m.nWidth,m.cFont,m.nSize,m.cTitle,m.nType

    *-- Ŀ
    *--  PURPOSE : Special box. Used for About box.                   
    *-- 

    PRIVATE m.cName

    m.cName = SYS( 2015 )              && Generate a random name

    IF ( EMPTY( m.cTitle ) )
        DEFINE WINDOW ( m.cName )            ;
            AT 0,0                           ;
            SIZE m.nHeight,m.nWidth          ;
            FONT m.cFont,m.nSize             ;
            NOMOVEABLE                       ;
            NOCLOSE                          ;
            NONE                             ;
            COLOR RGB(0,0,0,192,192,192)

    ELSE

        DEFINE WINDOW ( m.cName )            ;
            AT 0,0                           ;
            SIZE m.nHeight,m.nWidth          ;
            FONT m.cFont,m.nSize             ;
            TITLE m.cTitle                   ;
            MOVEABLE                         ;
            NOCLOSE                          ;
            NONE                             ;
            COLOR RGB(0,0,0,192,192,192)

    ENDIF

    ACTIVATE WINDOW (m.cName) NOSHOW   && Activate window but don't show it

    DO CASE                            && What kind of window do we like ?
        CASE ( m.nType == PAVE  )      && Type 1
            DO WIN_pave                && Launch appropriate service

        CASE ( m.nType == DALLE )      && Type 2
            DO WIN_dalle               && Launch appropriate service

    ENDCASE

    MOVE WINDOW (m.cName) CENTER       && Center window

RETURN ( m.cName )

*----------------------------------------------------------------------*

FUNCTION WIN_grave
    PARAMETERS m.nTop,m.nLeft,m.nBottom,m.nRight

    *-- Ŀ
    *--  PURPOSE : Draw a carved line in a specific region.           
    *-- 

    PRIVATE m.nH
    PRIVATE m.nW
    PRIVATE m.cFont
    PRIVATE m.nSize

    m.cFont  = WFONT( 1 )
    m.nSize  = WFONT( 2 )

    m.nH     = 1 / FONTMETRIC( 1,m.cFont,m.nSize )
    m.nW     = 1 / FONTMETRIC( 6,m.cFont,m.nSize )

    @ m.nTop     ,m.nLeft      TO m.nBottom     ,m.nRight      PEN 0 COLOR GRAY
    @ m.nTop+m.nH,m.nLeft+m.nW TO m.nBottom+m.nH,m.nRight+m.nW PEN 0 COLOR WHITE

RETURN ( .T. )

*----------------------------------------------------------------------*

PROCEDURE WIN_pave

    *-- Ŀ
    *--  PURPOSE : Draws a window that looks like a PAVE.             
    *-- 

    PRIVATE m.nTop
    PRIVATE m.nLeft
    PRIVATE m.nRight
    PRIVATE m.nBottom

    * Map screen coordinates to window coordinates

    m.nTop    = 0.2
    m.nLeft   = 0.5
    m.nRight  = WCOLS() - .16
    m.nBottom = WROWS() - .1

    * Dark box around area
    *---------------------
    @ 0,0                TO WROWS(),WCOLS()         PEN 0 COLOR BLACK

    * Light edge along top
    *---------------------
    @ 0.05,0.2           TO 0.05,m.nRight           PEN 0 COLOR WHITE
    @ 0.10,0.2           TO 0.10,m.nRight           PEN 0 COLOR WHITE
    @ 0.15,0.2           TO 0.15,m.nRight           PEN 0 COLOR WHITE

    * Light edge down left side
    *--------------------------
    @ 0.10,0.2           TO m.nBottom-0.1,0.2       PEN 0 COLOR WHITE
    @ 0.10,0.4           TO m.nBottom-0.1,0.4       PEN 0 COLOR WHITE

    * Dark edge along bottom of indented area
    *-----------------------------------------
    @ m.nBottom-0.10,0.4 TO m.nBottom-0.10,m.nRight PEN 0 COLOR GRAY
    @ m.nBottom-0.05,0.2 TO m.nBottom-0.05,m.nRight PEN 0 COLOR GRAY
    @ m.nBottom     ,0   TO m.nBottom     ,m.nRight PEN 0 COLOR GRAY

    * Dark edge along right side of indented area
    *---------------------------------------------
    @ 0.05,m.nRight      TO m.nBottom,m.nRight      PEN 0 COLOR GRAY
    @ 0.10,m.nRight-0.2  TO m.nBottom,m.nRight-0.2  PEN 0 COLOR GRAY
    @ 0.15,m.nRight-0.4  TO m.nBottom,m.nRight-0.4  PEN 0 COLOR GRAY

    @ m.nTop+5,m.nLeft+5 SAY ""

RETURN

*----------------------------------------------------------------------*

PROCEDURE WIN_dalle

    *-- Ŀ
    *--  PURPOSE : Draws a window that looks like a DALLE.            
    *-- 

    PRIVATE m.nTop
    PRIVATE m.nLeft
    PRIVATE m.nRight
    PRIVATE m.nBottom
    PRIVATE m.nRightLeft
    PRIVATE m.nBottomTop

    * Map screen coordinates to window coordinates

    m.nTop    = 0.2                    && 0.5
    m.nLeft   = 0.5                    && 0.7
    m.nRight  = WCOLS() - .16
    m.nBottom = WROWS() - .1

    m.nRightLeft = m.nRight  - m.nLeft && 1 calculation only
    m.nBottomTop = m.nBottom - m.nTop  && 1 calculation only

    * Dark edge along top of indented area
    *-------------------------------------
    @ m.nTop,m.nLeft       TO m.nTop,m.nRightLeft         PEN 0 COLOR GRAY


    * Dark edge along left side of indented area
    *-------------------------------------------
    @ m.nTop,m.nLeft       TO m.nBottomTop,m.nLeft        PEN 0 COLOR GRAY


    * Dark edge along bottom
    *-----------------------
    @ m.nBottom,0          TO m.nBottom,m.nRight          PEN 0 COLOR GRAY


    * Dark edge along right side
    *---------------------------
    @ 0,m.nRight           TO m.nBottom,m.nRight          PEN 0 COLOR GRAY


    * Light edge along top
    *---------------------
    @ 0,0                  TO 0,m.nRight                  PEN 0 COLOR WHITE


    * Light edge down left side
    *--------------------------
    @ 0,0                  TO m.nBottom,0                 PEN 0 COLOR WHITE


    * Light edge along bottom of indented area
    *-----------------------------------------
    @ m.nBottomTop,m.nLeft TO m.nBottomTop,m.nRightLeft   PEN 0 COLOR WHITE


    * Light edge along right side of indented area
    *---------------------------------------------
    @ m.nTop,m.nRightLeft    TO m.nBottomTop,m.nRightLeft PEN 0 COLOR WHITE

RETURN

*----------------------------------------------------------------------*

FUNCTION SCR_relief
    PARAMETERS m.cType,m.nTop,m.nLeft,m.nBottom,m.nRight

    *-- Ŀ
    *--  PURPOSE : Draws one of three borders.                        
    *-- 

    PRIVATE m.nEcart,m.nEcartc
    PRIVATE m.cFont
    PRIVATE m.nSize

    m.cFont   = WFONT( 1 )
    m.nSize   = WFONT( 2 )

    m.nEcart  = 3/FONTMETRIC( 1,m.cFont,m.nSize )
    m.nEcartc = 3/FONTMETRIC( 6,m.cFont,m.nSize )

    IF ( m.nBottom > WROWS() )
        m.nBottom = WROWS() - 0.500
    ENDIF

    IF ( m.nRight > WCOLS() )
        m.nRight = WCOLS() - 0.500
    ENDIF

    DO CASE
        CASE ( m.cType = "OMBRE" )
            @ m.nTop   ,m.nLeft    TO m.nBottom,m.nLeft  PEN 1,8           COLOR WHITE
            @ m.nTop   ,m.nLeft    TO m.nTop   ,m.nRight PEN 1,8 STYLE "1" COLOR WHITE
            @ m.nTop   ,m.nRight   TO m.nBottom,m.nRight PEN 1,8
            @ m.nBottom,m.nLeft    TO m.nBottom,m.nRight PEN 1,8 STYLE "1"

        CASE ( m.cType = "TRANCHEE" )
            @ m.nTop   ,m.nLeft    TO m.nBottom,m.nLeft  PEN 1,8
            @ m.nTop   ,m.nLeft    TO m.nTop   ,m.nRight PEN 1,8 STYLE "1"
            @ m.nTop   ,m.nRight   TO m.nBottom,m.nRight PEN 1,8           COLOR WHITE
            @ m.nBottom,m.nLeft    TO m.nBottom,m.nRight PEN 1,8 STYLE "1" COLOR WHITE

        CASE ( m.cType = "RIGOLE" )
            @ m.nTop   ,m.nLeft    TO m.nBottom,m.nLeft  PEN 1,8
            @ m.nTop   ,m.nLeft    TO m.nTop   ,m.nRight PEN 1,8 STYLE "1"
            @ m.nTop   ,m.nRight   TO m.nBottom,m.nRight PEN 1,8           COLOR WHITE
            @ m.nBottom,m.nLeft    TO m.nBottom,m.nRight PEN 1,8 STYLE "1" COLOR WHITE

            @ m.nTop    + m.nEcart    , ;
              m.nLeft   + m.nEcartc TO  ;
              m.nBottom - m.nEcart    , ;
              m.nLeft   + m.nEcartc     ;
            PEN 1,8                     ;
            COLOR WHITE

            @ m.nTop    + m.nEcart    , ;
              m.nLeft   + m.nEcartc TO  ;
              m.nTop    + m.nEcart    , ;
              m.nRight  - m.nEcartc     ;
            PEN 1,8                     ;
            STYLE "1"                   ;
            COLOR WHITE

            @ m.nTop    + m.nEcart    , ;
              m.nRight  - m.nEcartc TO  ;
              m.nBottom - m.nEcart    , ;
              m.nRight  - m.nEcartc     ;
            PEN 1, 8

            @ m.nBottom - m.nEcart    , ;
              m.nLeft   + m.nEcartc TO  ;
              m.nBottom - m.nEcart    , ;
              m.nRight  - m.nEcartc     ;
            PEN 1,8                     ;
            STYLE "1"

    ENDCASE

RETURN ( .T. )

*----------------------------------------------------------------------*

#define PIXELHEIGHT  169
#define PIXELWIDTH   322

FUNCTION Dialog
    PARAMETERS m.cType,m.cLine1,m.cLine2,m.cLine3,m.nSize,m.nAction

    *-- Ŀ
    *--  PURPOSE : Standard dialog boxes : INFO, STOP, WARNING        
    *-- 

    PRIVATE    m.nButton
    PRIVATE    m.cFont

    PRIVATE    m.nHeight                           && Window height
    PRIVATE    m.nWidth                            && Window width
    PRIVATE    m.nCharHeight
    PRIVATE    m.nCharWidth
    PRIVATE    m.nCol
    PRIVATE    m.nRow

    IF ( m.nSize == 0 )
        m.nSize = 10
    ENDIF

    m.cFont       = FNT_name()
    m.nCharHeight = FONTMETRIC( 1,m.cFont,m.nSize )
    m.nCharWidth  = FONTMETRIC( 6,m.cFont,m.nSize )
    m.nHeight     = PIXELHEIGHT / m.nCharHeight
    m.nWidth      = PIXELWIDTH  / m.nCharWidth

    DEFINE WINDOW wStop                         ;
        AT 0,0                                  ;
        SIZE m.nHeight,m.nWidth                 ;
        TITLE "Message de " + VER_name()        ;
        FONT m.cFont,m.nSize                    ;
        MOVEABLE                                ;
        NOCLOSE                                 ;
        NORESIZEABLE                            ;
        NOMAXIMIZE                              ;
        NONE                                    ;
        COLOR BACKGROUND

    ACTIVATE WINDOW wStop NOSHOW
    MOVE WINDOW wStop CENTER

    DO CASE
        CASE ( m.cType == "STOP" )
           @ 0,0 SAY "stop2.bmp" BITMAP

        CASE ( m.cType == "WARNING" )
           @ 0,0 SAY "stop3.bmp" BITMAP

        CASE ( m.cType == "INFO" .OR. m.cType == "INFONOWAIT" )
           @ 0,0 SAY "info.bmp"  BITMAP

        CASE ( m.cType == "YESNO" )
           @ 0,0 SAY "yesno.bmp"  BITMAP

    ENDCASE

    m.nCol = 60 / m.nCharWidth

    @ 01.0,m.nCol SAY m.cLine1 FONT m.cFont,m.nSize STYLE "B"
    @ 02.5,m.nCol SAY m.cLine2 FONT m.cFont,m.nSize STYLE "B"
    @ 04.0,m.nCol SAY m.cLine3 FONT m.cFont,m.nSize STYLE "B"

    m.nRow = 122 / m.nCharHeight
    m.nCol = ( ( PIXELWIDTH / 2 ) - ( 5 * m.nCharWidth ) ) / m.nCharWidth

    IF ( m.cType != "INFONOWAIT" )

        IF ( m.cType == "YESNO" )

            @ m.nRow,10     GET m.nAction               ;
                            PICTURE "@*HT \<Yes;\<No"   ;
                            SIZE 2.5,10,1               ;
                            FONT m.cFont,m.nSize        ;
                            STYLE "B"
        ELSE

            @ m.nRow,m.nCol GET m.nAction               ;
                            PICTURE "@*BHT ok2.bmp"     ;
                            SIZE 2.5,10                 ;
                            FONT m.cFont,FNT_size()
        ENDIF

        ACTIVATE WINDOW wStop

        READ MODAL

        RELEASE WINDOW wStop

    ELSE

        ACTIVATE WINDOW wStop

    ENDIF

RETURN ( .T. )

*----------------------------------------------------------------------*

PROCEDURE NiceGet
    PARAMETERS aGets,m.cFont,nSize,cStyle

    *-- Ŀ
    *--  This procedure seems to be a little tricky and in fact it IS 
    *--                                                               
    *--  PURPOSE : draws different boxes around a GET in order to     
    *--            create 3D effects.                                 
    *-- 

    PRIVATE m.i
    PRIVATE m.nRatio
    PRIVATE m.nPixH

    PRIVATE m.nTop
    PRIVATE m.nLeft
    PRIVATE m.nBottom
    PRIVATE m.nRight

    m.nRatio = 1 / FONTMETRIC( 1,m.cFont,m.nSize )
    m.nPixH  = 1 / FONTMETRIC( 2,m.cFont,m.nSize )

    m.i = 0

    DO WHILE ( m.i < ALEN( aGets,1 ) )

        m.i = m.i + 1

        m.nTop    = aGets[i,1] - 2 * m.nRatio
        m.nLeft   = aGets[i,2] - 0.400
        m.nBottom = aGets[i,1] + aGets[i,3] + m.nRatio
        m.nRight  = aGets[i,2] + aGets[i,4] + 0.100

        IF ( m.nBottom > WROWS() )
            m.nBottom = WROWS() - 0.500
        ENDIF

        IF ( nRight > WCOLS() )
            m.nRight = WCOLS() - 0.500
        ENDIF

        @ m.nTop   ,m.nLeft  TO                                ;
          m.nBottom,m.nLeft PEN 1,8 COLOR GRAY_LIGHT

        @ m.nTop   ,m.nLeft  TO                                ;
          m.nTop,m.nRight PEN 1,8 STYLE "1" COLOR GRAY_LIGHT

        @ m.nTop   ,m.nRight TO                                ;
          m.nBottom+nRatio,nRight PEN 1,8 COLOR RGB(255,255,255,192,192,192)

        @ m.nBottom,m.nLeft  TO                                ;
          m.nBottom,m.nRight PEN 1,8 STYLE "1" COLOR RGB(255,255,255,192,192,192)

        @ m.nTop       + m.nRatio   , ;
          m.nLeft      + m.nPixH TO   ;
          m.nBottom    - m.nRatio   , ;
          m.nLeft      + m.nPixH      ;
            PEN 1,8                   ;
            COLOR RGB(0,0,0,192,192,192)

        @ m.nTop       + m.nRatio   , ;
          m.nLeft      + m.nPixH TO   ;
          m.nTop       + m.nRatio   , ;
          m.nRight     - m.nPixH      ;
            PEN 1, 8                  ;
            STYLE "1"                 ;
            COLOR RGB(0,0,0,192,192,192)

        @ m.nTop       + m.nRatio   , ;
          m.nRight     - m.nPixH TO   ;
          m.nBottom    - m.nRatio   , ;
          m.nRight     - m.nPixH      ;
            PEN 1, 8                  ;
            COLOR LIGHT_GRAY

        @ m.nBottom    - m.nRatio   , ;
          m.nLeft      + m.nPixH TO   ;
          m.nBottom    - m.nRatio   , ;
          m.nRight     - m.nPixH      ;
            PEN 1, 8                  ;
            STYLE "1"                 ;
            COLOR LIGHT_GRAY

    ENDDO

RETURN

*----------------------------------------------------------------------*

FUNCTION BrowseButt
    PARAMETER m.cSection

    PRIVATE   m.nRow
    PRIVATE   m.cOldSep
    PRIVATE   m.cButt2
    PRIVATE   m.cButt3
    PRIVATE   m.cButtons
    PRIVATE   m.nTokens
    PRIVATE   m.cToken
    PRIVATE   m.i
    PRIVATE m.cMainSep
    PRIVATE m.cSecoSep


    =EVE_end()

    m.cMainSep = ""
    m.cSecoSep = ""
    m.nRow     = WROWS() - 3
    m.cOldSep  = STR_setsep( m.cMainSep )
    m.cButtons = FIL_reaini( m.cSection,"Buttons1",VER_ini() )
    m.cButt2   = FIL_reaini( m.cSection,"Buttons2",VER_ini() )
    m.cButt3   = FIL_reaini( m.cSection,"Buttons3",VER_ini() )

    IF ( ! EMPTY( m.cButt2 ) )
        m.cButtons = m.cButtons + m.cMainSep + m.cButt2
    ENDIF

    IF ( ! EMPTY( m.cButt3 ) )
        m.cButtons = m.cButtons + m.cMainSep + m.cButt3
    ENDIF

    m.nTokens  = STR_numtok( m.cButtons)

    FOR m.i = 1 TO m.nTokens

        m.cToken = STR_ntoken( m.i,m.cButtons )

        =STR_setsep( m.cSecoSep )
        @ m.nRow,VAL( ALLTRIM( STR_ntoken( 1,m.cToken ) ) ) SAY ;
             STR_ntoken( 2,m.cToken ) + ".000" BITMAP

        =STR_setsep( m.cMainSep )

    NEXT

    =STR_setsep( m.cOldSep )
    =EVE_start()

RETURN ( .T. )

*----------------------------------------------------------------------------*

FUNCTION BrowseClick
    PARAMETERS m.cSection,m.cAlias,m.nMouseRow,m.nMouseCol

    *-- Ŀ
    *--  PURPOSE : handles mouse click in K7 BROWSE.                  
    *-- 

    PRIVATE m.nRows_3
    PRIVATE m.nRows_1
    PRIVATE m.cOldSep
    PRIVATE m.cButt2
    PRIVATE m.cButt3
    PRIVATE m.cButtons
    PRIVATE m.nTokens
    PRIVATE m.cToken
    PRIVATE m.i
    PRIVATE m.lFound
    PRIVATE m.cWindow
    PRIVATE m.cAlias
    PRIVATE aButtons
    PRIVATE m.cMainSep
    PRIVATE m.cSecoSep

    m.nRows_3  = WROWS() - 3
    m.nRows_1  = WROWS() - 1
    m.lFound   = .F.

    m.cMainSep = ""
    m.cSecoSep = ""

    IF ( BETWEEN( m.nMouseRow,m.nRows_3,m.nRows_1 ) )

        m.cOldSep  = STR_setsep( m.cMainSep )
        m.cButtons = FIL_reaini( m.cSection,"Buttons1",VER_ini() )
        m.cButt2   = FIL_reaini( m.cSection,"Buttons2",VER_ini() )
        m.cButt3   = FIL_reaini( m.cSection,"Buttons3",VER_ini() )
        m.cWindow  = FIL_reaini( m.cSection,"Window"  ,VER_ini() )

        ACTIVATE WINDOW ( m.cWindow )
        SELECT ( m.cAlias )

        IF ( ! EMPTY( m.cButt2 ) )
            m.cButtons = m.cButtons + m.cMainSep + m.cButt2
        ENDIF

        IF ( ! EMPTY( m.cButt3 ) )
            m.cButtons = m.cButtons + m.cMainSep + m.cButt3
        ENDIF

        m.nTokens  = STR_numtok( m.cButtons)

        DIMENSION aButtons[m.nTokens,3]

        FOR m.i = 1 TO m.nTokens

            m.cToken = STR_ntoken( m.i,m.cButtons )

            =STR_setsep( m.cSecoSep )

            aButtons[m.i,1] = VAL( ALLTRIM( STR_ntoken( 1,m.cToken ) ) )
            aButtons[m.i,2] = STR_ntoken( 2,m.cToken )
            aButtons[m.i,3] = STR_ntoken( 3,m.cToken )

            =STR_setsep( m.cMainSep )

        NEXT

        =STR_setsep( m.cOldSep )

        FOR m.i = 1 TO m.nTokens

            IF ( BETWEEN( m.nMouseCol,aButtons[m.i,1],aButtons[m.i,1] + 5 ) )

                @ m.nRows_3,aButtons[m.i,1] SAY aButtons[m.i,2] + ".001" BITMAP

                DO WHILE ( MDOWN() )
                ENDDO

                @ m.nRows_3,aButtons[m.i,1] SAY aButtons[m.i,2] + ".000" BITMAP

                =DDA_execut( aButtons[m.i,3] )

                m.lFound = .T.

                EXIT

            ENDIF

        NEXT

        IF ( ! m.lFound )

            IF ( BETWEEN( m.nMouseRow,WROWS()-2,m.nRows_1 ) )

                DO CASE
                    CASE BETWEEN( m.nMouseCol,WCOLS()-22,WCOLS()-20 )
                        GO TOP

                    CASE BETWEEN( m.nMouseCol,WCOLS()-17,WCOLS()-15 )
                        GO BOTTOM
                ENDCASE

            ENDIF

        ENDIF

    ENDIF

RETURN ( .T. )

*----------------------------------------------------------------------------*

FUNCTION DBF_scroll
    PARAMETERS m.cIniFile,m.cSection,m.cAlias,m.cTitleCh

    *-- Ŀ
    *--  PURPOSE : standard BROWSE function.                          
    *--                                                               
    *--  PARAMETERS: m.cIniFile   Name of INI file                    
    *--              m.cSection   Section of INI file                 
    *--              m.cAlias     Alias of file                       
    *--              m.cTitleCh   Title of child window               
    *--                                                               
    *-- 

    PRIVATE m.cWinName                 && Window name
    PRIVATE m.cTitlePa                 && Parent window title
    PRIVATE m.cWhenBlock               && WHEN block of BROWSE command
    PRIVATE m.cPostBrowse              && Command to be executed after BROWSE
    PRIVATE m.nHeight                  && Height of parent window
    PRIVATE m.nWidth                   && Width of parent window
    PRIVATE m.cFont                    && Font of parent window
    PRIVATE m.nSize                    && Font size of parent window
    PRIVATE m.nRow                     && Row location of parent window
    PRIVATE m.nCol                     && Col location of parent window
    PRIVATE m.nCharHeight              && Height of a character
    PRIVATE m.nCharWidth               && Width of a character
    PRIVATE m.nScrollWSize             && Width of scroll bars
    PRIVATE m.nTitleHeight             && Height of the title
    PRIVATE m.cField1                  && Temporary variable 1
    PRIVATE m.cField2                  && Temporary variable 2
    PRIVATE m.cField3                  && Temporary variable 3
    PRIVATE m.lCanMove                 && FLOAT | NOFLOAT window ?
    PRIVATE m.lCanGrow                 && GROW | NOGROW window
    PRIVATE m.cMoveGrow                && Tmp var for macro
    PRIVATE m.cFiller                  && Filler BMP for parent window

    && These variables cannot be prefixed with the m alias (m.) because
    && they will be used in macros.
    PRIVATE cFor                       && FOR condition if any
    PRIVATE cFields                    && BROWSE fields
    PRIVATE cMode                      && BROWSE mode (NOMENU, NOEDIT, etc.)
    PRIVATE cColor                     && BROWSE color spec
    PRIVATE cStyle                     && Font style of parent window

    IF ( ALLTRIM( ALIAS() ) != UPPER( ALLTRIM( m.cAlias ) ) )
        SELECT ( m.cAlias )            && Select appropriate work area
    ENDIF

    m.cWinName    = FIL_reaini( m.cSection,"Window"     ,m.cIniFile )
    m.cTitlePa    = FIL_reaini( m.cSection,"WindowTitle",m.cIniFile )

    IF ( LEFT( m.cTitlePa,1 ) == "$" )
        m.cTitlePa = DDA_evalua( SUBSTR( m.cTitlePa,2 ) )
    ENDIF

    cWhenBlock    = FIL_reaini( m.cSection,"WhenBlock"  ,m.cIniFile )
    cFor          = FIL_reaini( m.cSection,"For"        ,m.cIniFile )
    m.cPostBrowse = FIL_reaini( m.cSection,"PostBrowse" ,m.cIniFile )
    m.lCanMove    = ( FIL_reaini( m.cSection,"CanMove" ,VER_ini() ) == "ON" )
    m.lCanGrow    = ( FIL_reaini( m.cSection,"CanGrow" ,VER_ini() ) == "ON" )

    IF ( m.lCanMove )
        m.cMoveGrow = "FLOAT"
    ELSE
        m.cMoveGrow = "NOFLOAT"
    ENDIF
    
    IF ( m.lCanGrow )
        m.cMoveGrow = m.cMoveGrow + " " + "GROW"
    ELSE
        m.cMoveGrow = m.cMoveGrow + " " + "NOGROW"
    ENDIF

    IF ( ! WEXIST( m.cWinName ) )      && If window does not already exist

        IF ( EMPTY( cWhenBlock ) )     && If empty parameter
            cWhenBlock = ".T."         && Fill it with default value
        ENDIF

        m.nRow        = VAL( FIL_reaini( m.cSection,"Row"    ,m.cIniFile ) )
        m.nCol        = VAL( FIL_reaini( m.cSection,"Col"    ,m.cIniFile ) )
        m.nHeight     = VAL( FIL_reaini( m.cSection,"Height" ,m.cIniFile ) )
        m.nWidth      = VAL( FIL_reaini( m.cSection,"Width"  ,m.cIniFile ) )
        m.cFont       = FNT_name()
        m.nSize       = FNT_size()
        m.cField1     =      FIL_reaini( m.cSection,"Fields1",m.cIniFile )
        m.cField2     =      FIL_reaini( m.cSection,"Fields2",m.cIniFile )
        m.cField3     =      FIL_reaini( m.cSection,"Fields3",m.cIniFile )

        cMode         =      FIL_reaini( m.cSection,"Mode"   ,m.cIniFile )
        cStyle        =      FIL_reaini( m.cSection,"Style"  ,m.cIniFile )
        cColor        =      FIL_reaini( m.cSection,"Color"  ,m.cIniFile )

        m.cFiller     =      FIL_reaini( m.cSection,"Filler" ,m.cIniFile )

        m.nCharHeight = FONTMETRIC( 1,m.cFont,m.nSize )
        m.nCharWidth  = FONTMETRIC( 6,m.cFont,m.nSize )

        cFields       = m.cField1

        IF ( ! EMPTY( m.cField2 ) )
            cFields = cFields + "," + m.cField2
        ENDIF

        IF ( ! EMPTY( m.cField3 ) )
            cFields = cFields + "," + m.cField3
        ENDIF

        IF ( EMPTY( cMode ) )
            cMode = "NOMENU NOWAIT"
        ENDIF

        IF ( EMPTY( m.cFiller ) )

            DEFINE WINDOW ( m.cWinName )                                    ;
                AT m.nRow,m.nCol                                            ;
                SIZE m.nHeight,m.nWidth                                     ;
                FONT m.cFont,m.nSize                                        ;
                STYLE cStyle                                                ;
                &cMoveGrow                                                  ;
                NOCLOSE                                                     ;
                MINIMIZE                                                    ;
                MAXIMIZE                                                    ;
                TITLE m.cTitlePa                                            ;
                SYSTEM                                                      ;
                ICON FILE ( m.gcRunPath + "BROWSE.ICO" )                    ;
                COLOR BACKGROUND

        ELSE

            DEFINE WINDOW ( m.cWinName )                                    ;
                AT m.nRow,m.nCol                                            ;
                SIZE m.nHeight,m.nWidth                                     ;
                FONT m.cFont,m.nSize                                        ;
                STYLE cStyle                                                ;
                &cMoveGrow                                                  ;
                NOCLOSE                                                     ;
                MINIMIZE                                                    ;
                MAXIMIZE                                                    ;
                TITLE m.cTitlePa                                            ;
                SYSTEM                                                      ;
                ICON FILE ( m.gcRunPath + "BROWSE.ICO" )                    ;
                FILL FILE ( m.cFiller )                                     ;
                COLOR BACKGROUND

        ENDIF

        m.nTitleHeight  = SYSMETRIC( 9 ) / m.nCharHeight
        m.nScrollWSize  = SYSMETRIC( 5 ) / m.nCharWidth

        DEFINE WINDOW wChild                                                ;
            AT - m.nTitleHeight,0                                           ;
            SIZE m.nHeight - 4 - m.nTitleHeight,m.nWidth - m.nScrollWSize   ;
            FONT m.cFont,m.nSize                                            ;
            STYLE cStyle                                                    ;
            IN WINDOW ( m.cWinName )                                        ;
            TITLE m.cTitleCh                                                ;
            COLOR BACKGROUND

        IF ( EMPTY( cFor ) )

            *-- Issue the BROWSE command
            BROWSE FIELDS &cFields                                          ;
                FONT m.cFont,m.nSize                                        ;
                &cMode                                                      ;
                COLOR &cColor                                               ;
                WINDOW wChild                                               ;
                IN WINDOW ( m.cWinName )                                    ;
                SAVE                                                        ;
                WHEN &cWhenBlock

        ELSE

            *-- Issue the BROWSE command
            BROWSE FIELDS &cFields                                          ;
                FOR DDA_evalua( cFor )                                      ;
                FONT m.cFont,m.nSize                                        ;
                &cMode                                                      ;
                COLOR &cColor                                               ;
                WINDOW wChild                                               ;
                IN WINDOW ( m.cWinName )                                    ;
                SAVE                                                        ;
                WHEN &cWhenBlock
        ENDIF

        *-- Release the child window once we no longer need it
        RELEASE WINDOW wChild

        ACTIVATE WINDOW ( m.cWinName )

        IF ( ! EMPTY( m.cPostBrowse ) )
            =EVALUATE( m.cPostBrowse + "(m.nHeight,m.nWidth)" )
        ENDIF

    ELSE

        ACTIVATE WINDOW ( m.cWinName )

    ENDIF

RETURN ( .T. )

*----------------------------------------------------------------------------*

FUNCTION StdEntry
    PARAMETERS m.cTitleAdd  , ;
               m.cTitleEdit , ;
               m.cCodeBlock , ;
               m.cSection   , ;
               m.cAlias     , ;
               aArrayEntry  , ;
               m.cActiWin   , ;
               m.cDataOK

    PRIVATE m.cEntryType               && Standard or Extended
    PRIVATE m.nRow                     && Top of window
    PRIVATE m.nCol                     && Left of window
    PRIVATE m.nHlpCode                 && Internal help code
    PRIVATE m.nButtLine                && Row where buttons are displayed
    PRIVATE m.nButtCol                 && Col where buttons are displayed
    PRIVATE m.nButton                  && GET push button #1
    PRIVATE m.nButton2                 && GET push button #2
    PRIVATE m.lQuitting                && Should we release window ?
    PRIVATE m.lFromButton              && Push button pressed ?
    PRIVATE m.cWinTitle                && Window title
    PRIVATE m.cPrePGM                  && Pre PGM
    PRIVATE m.cPostPGM                 && Post PGM
    PRIVATE m.cSaysPGM                 && Says
    PRIVATE m.cGetsPGM                 && Gets
    PRIVATE m.cDefiPGM                 && Window definition
    PRIVATE m.cDejaPGM                 && Dj vu mode
    PRIVATE m.cAjedPGM                 && Opposite to Dj vu mode
    PRIVATE m.cBefReplPGM              && Before REPLACE
    PRIVATE m.cAftReplPGM              && After REPLACE
    PRIVATE m.cWindow                  && Window name
    PRIVATE m.cAddButt                 && Additional buttons
    PRIVATE m.cValidButt               && Valid clause for additional buttons
    PRIVATE m.nLastGet                 && Last GET number
    PRIVATE m.lRelease                 && Release after OK ?

    PRIVATE aGets                      && 3D GETs array

    m.lQuitting   = .F.                && By default
    m.lFromButton = .F.                && By default

    && First : read settings from INI file
    m.nButton     = 1                    && Prepare GET
    m.nButtLine   = VAL( FIL_reaini( m.cSection,"ButtonRow"   ,VER_ini() ) )
    m.nButtCol    = VAL( FIL_reaini( m.cSection,"ButtonCol"   ,VER_ini() ) )
    m.lRelease    = ( FIL_reaini( m.cSection,"OKRelease",VER_ini() ) == "ON" )
    m.cPrePGM     =      FIL_reaini( m.cSection,"PrePGM"      ,VER_ini() )
    m.cPostPGM    =      FIL_reaini( m.cSection,"PostPGM"     ,VER_ini() )
    m.cSaysPGM    =      FIL_reaini( m.cSection,"SaysPGM"     ,VER_ini() )
    m.cGetsPGM    =      FIL_reaini( m.cSection,"GetsPGM"     ,VER_ini() )
    m.cDefiPGM    =      FIL_reaini( m.cSection,"DefiPGM"     ,VER_ini() )
    m.cDejaPGM    =      FIL_reaini( m.cSection,"DejaPGM"     ,VER_ini() )
    m.cAjedPGM    =      FIL_reaini( m.cSection,"AjedPGM"     ,VER_ini() )
    m.cBefReplPGM =      FIL_reaini( m.cSection,"BefReplPGM"  ,VER_ini() )
    m.cAftReplPGM =      FIL_reaini( m.cSection,"AftReplPGM"  ,VER_ini() )
    m.cWindow     =      FIL_reaini( m.cSection,"Window"      ,VER_ini() )
    m.NewHlpCode  = VAL( FIL_reaini( m.cSection,"HelpCode"    ,VER_ini() ) )
    m.cAddButt    =      FIL_reaini( m.cSection,"AddButtons"  ,VER_ini() )
    m.cValidButt  =      FIL_reaini( m.cSection,"AddButtValid",VER_ini() )
    m.cMode       =      FIL_reaini( m.cSection,"WindowMode"  ,VER_ini() )
    m.nLastGet    = VAL( FIL_reaini( m.cSection,"LastGet"     ,VER_ini() ) )

    && If no window defined ... return
    IF ( EMPTY( m.cWindow ) )
        RETU ( .F. )                   && Immediate return
    ENDIF

    m.nHlpCode    = HLP_code( NewHlpCode ) && Position a new help code

    =DDA_filexe( m.cPrePGM )           && Pre PGM to execute

    SELECT ( m.cAlias )                && Select appropriate work area

    && Initialization of GET variables
    IF ( LEN( aArrayEntry[1] ) == 0 )  && Did we come from here ? No ...
        IF ( m.cMode == "ADD" )        && New record requested
            SCATTER MEMVAR BLANK MEMO  && Get values from fields (blank)
        ELSE
            SCATTER MEMVAR MEMO        && Get values from fields
        ENDIF
    ELSE                               && Otherwise ...
        =DDA_filexe( m.cDejaPGM )      && Take GET values from array
    ENDIF

    IF ( ! WEXIST( m.cWindow ) )       && If window does not exist, create it!

        && Row and Col from INI file
        m.nRow = VAL( FIL_reaini( m.cSection,"Row",VER_ini() ) )
        m.nCol = VAL( FIL_reaini( m.cSection,"Col",VER_ini() ) )

        IF ( m.cMode == "ADD" )        && ADD mode ?
            m.cWinTitle = m.cTitleAdd  &&  Yes => Window title is m.cTitleAdd
        ELSE                           
            m.cWinTitle = m.cTitleEdit &&  No => Window title is m.cTitleEdit
        ENDIF

        =DDA_filexe( m.cDefiPGM )      && Get window definition

        IF ( ! WEXIST( m.cWindow ) )   && If window creation failed ...
            =WIN_nowait( "No window defined" )
            RETU ( .F. )               && Immediate return
        ENDIF

        =AddDelWin( m.cActiWin,"ADD" ) && Adapt Windows popup menu

        ACTIVATE WINDOW (m.cWindow) NOSHOW

        =DDA_filexe( m.cSaysPGM )      && All says

    ELSE                               && Window is already existing

        m.cWinTitle = WTITLE( m.cWindow )

        IF ( "MODIFY" $ m.cWinTitle )
            IF ( m.cMode != "EDIT" )
                MODIFY WINDOW ( m.cWindow ) TITLE m.cTitleAdd
            ENDIF

            ACTIVATE WINDOW ( m.cWindow ) SAME

        ELSE
            IF ( m.cMode != "ADD" )
                MODIFY WINDOW ( m.cWindow ) TITLE m.cTitleEdit
            ENDIF

            ACTIVATE WINDOW ( m.cWindow ) SAME

        ENDIF

    ENDIF

    IF ( m.cMode = "ADD" ) && APPEND mode ?
        =DDA_execut( m.cCodeBlock )
    ENDIF

    && Issue all GETs now, except buttons
    =DDA_filexe( m.cGetsPGM )

    IF ( ( m.nButtLine + 02.50 ) > WROWS() )
        m.nButtLine = WROWS() - 3
    ENDIF

    @ m.nButtLine,m.nButtCol GET m.nButton                     ;
                    PICTURE "@*BHT ok2.bmp;cancel.bmp"         ;
                    SIZE 02.50,12.00,01.00                     ;
                    VALID SetFrom( @m.lFromButton,.T. )

    IF ( ! EMPTY( m.cAddButt ) )       && If additional buttons

        IF ( EMPTY( m.cValidButt ) )   && If no validation on 2nd button set
            m.cValidButt = ".T."
        ENDIF

        @ m.nButtLine,m.nButtCol + 30 GET m.nButton2        ;
                  PICTURE m.cAddButt                        ;
                  SIZE 02.50,14.00,01.00                    ;
                  DEFAULT 1                                 ;
                  VALID DDA_evalua( m.cValidButt )          ;
                  STYLE "B"

    ENDIF

    IF ( ! WVISIBLE( m.cWindow ) )
        ACTIVATE WINDOW ( m.cWindow )  && then ... show it !
    ENDIF

    READ CYCLE DEACTIVATE StopRead( m.cWindow,@m.lQuitting );
         VALID SaveLastGet( @m.nLastGet )                   ;
         OBJECT m.nLastGet

    && Saving Last GET information
    =FIL_wriini( m.cSection,"LastGet",ALLTRIM( STR( m.nLastGet ) ),VER_ini() )

    IF ( m.nButton == 2 .OR. m.lRelease ) && Cancel button ?
        m.lQuitting = .T.              && Must release window and quit
    ENDIF

    IF ( m.lQuitting )                 && Should we release window ?
        =AddDelWin( m.cActiWin,"DEL" ) && Adapt Windows PAD
        =WIN_kill( m.cWindow,m.cSection,VER_ini(),"ENTRY" )
    ENDIF

    IF ( m.lFromButton )               && Did we press a terminate button ?

        IF ( m.nButton == 1 )          && Save button ?

            IF ( DDA_evalua( m.cDataOK ) ) && If adequate info entered

                IF ( ! EMPTY( m.cBefReplPGM ) )
                    =DDA_filexe( m.cBefReplPGM )
                ENDIF

                IF ( m.cMode = "ADD" ) && APPEND mode ?
                    =DBF_appblk(1)
                    GATHER MEMVAR MEMO
                ELSE
                    GATHER MEMVAR MEMO
                    GO ( RECNO() )     && Refresh current record in a BROWSE
                ENDIF

                IF ( ! EMPTY( m.cAftReplPGM ) )
                    =DDA_filexe( m.cAftReplPGM )
                ENDIF

            ENDIF

        ENDIF

        =ARR_fill( @aArrayEntry,"" )   && Blank array

    ELSE
        =DDA_filexe( m.cAjedPGM )      && Save variables to array
    ENDIF

    =DDA_filexe( m.cPostPGM )          && Post PGM to execute

    =HLP_code( m.nHlpCode )            && Reset Help Code to previous state

RETURN ( m.nButton == 1 )

*----------------------------------------------------------------------*

PROCEDURE Wall

    *-- Ŀ
    *--  PURPOSE : changes WALLPAPER (user interface function)        
    *-- 

    PRIVATE m.cBmp
    PRIVATE m.lFillFile
    PRIVATE m.lCenterFile
    PRIVATE m.nButton1
    PRIVATE m.nButton2
    PRIVATE m.cWindow

    =TRA_log( IN_PROGRAM )             && Tracing instruction

    m.lFillFile   = .T.
    m.lCenterFile = .F.
    m.nButton1    = 1
    m.nButton2    = 1

    m.cWindow     = WIN_mdialg( 11.00,54.40 , ;
                                FNT_name()  , ;
                                FNT_size()  , ;
                                ""          , ;
                                DALLE )

    ACTIVATE WINDOW ( m.cWindow ) NOSHOW
    MOVE WINDOW ( m.cWindow ) CENTER

    =WIN_grave( 01.00,02.40,07.00,32  )
    =WIN_grave( 07.50,02.40,10.00,52  )

    @ 00.55,04.00 SAY "Papier-peint" STYLE "B"
    =ShrinkImage()

    @ 02.50,04.00 GET m.lFillFile                   ;
                  PICTURE "@*C Changer le fond ?"   ;
                  SIZE 1.308,10.667                 ;
                  STYLE "T"

    @ 04.00,04.00 GET m.lCenterFile                 ;
                  PICTURE "@*C Changer l'image ?"   ;
                  SIZE 1.308,14.167                 ;
                  STYLE "T"

    @ 08.00,03.40 GET m.nButton1                    ;
                  PICTURE "@*HN \<Appliquer"        ;
                  SIZE 01.75,12.00,00.00            ;
                  VALID ChangeWall( lFillFile     , ;
                                    lCenterFile )   ;
                  STYLE "B"

    @ 08.00,16.40 GET m.nButton2                    ;
                  PICTURE "@*HT \<Fermer"           ;
                  SIZE 01.75,12.00,00.00            ;
                  STYLE "B"

    ACTIVATE WINDOW ( m.cWindow )

    READ CYCLE MODAL

    RELEASE WINDOW ( m.cWindow )

    =TRA_log( OUT_PROGRAM )            && Tracing instruction

RETURN

*----------------------------------------------------------------------*

FUNCTION ShrinkImage

    @ 01.00,33.40 CLEAR TO 07.00,52 COLOR LIGHT_GRAY
    =WIN_grave( 01.00,33.40,07.00,52  )

    IF ( ! EMPTY( DSK_center() ) .AND. FILE( DSK_center() ) )
        @ 01.40,34.40 SAY DSK_center() BITMAP SIZE 5.5,16.60 ISOMETRIC
    ELSE
        @ 01.40,34.40 SAY "WALL.BMP"   BITMAP SIZE 5.5,16.60 ISOMETRIC
    ENDIF

RETURN ( .T. )

*----------------------------------------------------------------------*

FUNCTION ChangeWall
    PARAMETERS m.lFill,m.lCenter

    *-- Ŀ
    *--  PURPOSE : changes WALLPAPER. Redisplays the FILLER and the   
    *--            image to be centered.                              
    *-- 

    PRIVATE m.cOnTop
    PRIVATE m.cBMP
    PRIVATE m.lIsEvent

    m.cOnTop   = WONTOP()
    m.lIsEvent = EVE_isacti()

    IF ( m.lIsEvent )
        =EVE_end()
    ENDIF

    *-- Ŀ
    *--  1) Process the Filler first 
    *-- 

    IF ( m.lFill )

        *-- Ask the user to select a BMP file
        m.cBMP = GETFILE( "BMP","Filler BMP","Open",0 )

        IF ( ! EMPTY( m.cBMP ) )
            MODIFY WINDOW SCREEN          ;
                TITLE DSK_title()         ;
                FILL FILE ( cBMP )

            =DSK_fill( m.cBMP )        && Position the PUBLIC variable

            *-- If no new to be centerd image ... be sure to redisplay
            *-- old one !!!
            IF ( ! m.lCenter )
                IF ( FILE( DSK_center() ) )
                    ACTIVATE Screen        && Activate Desktop
                    @ 0,0 SAY DSK_center() BITMAP CENTER
                    ACTIVATE WINDOW ( m.cOnTop )
                ENDIF
            ENDIF

        ENDIF

    ENDIF

    *-- Ŀ
    *--  2) Process the image that must be centered 
    *-- 

    IF ( m.lCenter )

        *-- Ask the user to select a BMP file
        m.cBMP = GETFILE( "BMP","Centered BMP","Open",0 )

        IF ( ! EMPTY( m.cBMP ) )

            =DSK_center( m.cBMP )      && Position the PUBLIC variable

            IF ( FILE( DSK_center() ) )
                ACTIVATE SCREEN            && Activate Desktop
                CLEAR
                @ 0,0 SAY DSK_center() BITMAP CENTER
                ACTIVATE WINDOW ( m.cOnTop )
                =ShrinkImage()
            ENDIF

        ENDIF

    ENDIF

    IF ( m.lIsEvent )
        =EVE_start()
    ENDIF

RETURN ( .T. )

*----------------------------------------------------------------------*

FUNCTION WIN_save
    PARAMETERS m.cWindow,m.cINISection,m.cINIFile,m.cType

    *-- Ŀ
    *--  PURPOSE : saves a window location and dimensions into the    
    *--            application INI file.                              
    *-- 

    =TRA_log( IN_PROGRAM )             && Tracing instruction

    DO CASE
        CASE ( m.cType == "BROWSE" )
            =FIL_wriini( m.cINISection,"Row"   ,ALLTRIM(STR(WLROW(m.cWindow),5,2)),m.cINIFile )
            =FIL_wriini( m.cINISection,"Col"   ,ALLTRIM(STR(WLCOL(m.cWindow),5,2)),m.cINIFile )
            =FIL_wriini( m.cINISection,"Height",ALLTRIM(STR(WROWS(m.cWindow),5,2)),m.cINIFile )
            =FIL_wriini( m.cINISection,"Width" ,ALLTRIM(STR(WCOLS(m.cWindow),5,2)),m.cINIFile )

        CASE ( m.cType == "EXTENDED ENTRY" )
            =FIL_wriini( m.cINISection,"Row",ALLTRIM(STR(WLROW(m.cWindow),5,2)),m.cINIFile )
            =FIL_wriini( m.cINISection,"Col",ALLTRIM(STR(WLCOL(m.cWindow),5,2)),m.cINIFile )

        CASE ( m.cType == "ENTRY" )
            =FIL_wriini( m.cINISection,"Row",ALLTRIM(STR(WLROW(m.cWindow),5,2)),m.cINIFile )
            =FIL_wriini( m.cINISection,"Col",ALLTRIM(STR(WLCOL(m.cWindow),5,2)),m.cINIFile )

    ENDCASE

    =TRA_log( OUT_PROGRAM )            && Tracing instruction

RETURN ( .T. )

*----------------------------------------------------------------------------*

FUNCTION WIN_kill
    PARAMETERS m.cWinName,m.cINISection,m.cINIFile,m.cType

    *-- Ŀ
    *--  PURPOSE : saves window (WIN_save()) and kills given window.  
    *-- 

    =WIN_save( m.cWinName,m.cINISection,m.cINIFile,m.cType )

    RELEASE WINDOW ( m.cWinName )

RETURN ( .T. )

*----------------------------------------------------------------------------*

FUNCTION GEN_activa
    PARAMETERS m.cType      , ;
               m.cSection   , ;
               m.cAlias     , ;
               m.cField     , ;
               m.cWindow    , ;
               m.cTitle

    *-- Ŀ
    *--  PURPOSE : activates a standard MODIFY GENERAL command.       
    *-- 

    PRIVATE m.cChildWin
    PRIVATE m.nTitleHeight
    PRIVATE m.nBorderHeight
    PRIVATE m.nBorderWidth
    PRIVATE m.nScrollWidth
    PRIVATE m.nCharHeight
    PRIVATE m.nCharWidth               && Width of a character
    PRIVATE m.nRow
    PRIVATE m.nHeight
    PRIVATE m.nWidth

    =EVE_end()                         && Stop events polling
    =TRA_log( IN_PROGRAM )             && Tracing instruction

    IF ( UPPER( ALLTRIM( ALIAS() ) ) != UPPER( ALLTRIM( m.cAlias ) ) )
        SELECT ( m.cAlias )
    ENDIF

    m.nHeight       = VAL( FIL_reaini( m.cSection,"Height",VER_ini() ) )
    m.nWidth        = VAL( FIL_reaini( m.cSection,"Width" ,VER_ini() ) )
    m.nRow          = VAL( FIL_reaini( m.cSection,"Row"   ,VER_ini() ) )
    m.nCol          = VAL( FIL_reaini( m.cSection,"Col"   ,VER_ini() ) )

    m.nCharHeight   = FONTMETRIC( 1,FNT_name(),FNT_size() )
    m.nCharWidth    = FONTMETRIC( 6,FNT_name(),FNT_size() )

    m.nBorderHeight =   SYSMETRIC( 4 ) / m.nCharHeight
    m.nBorderWidth  =   SYSMETRIC( 3 ) / m.nCharWidth
    m.nScrollWidth  =   SYSMETRIC( 5 ) / m.nCharWidth
    m.nTitleHeight  = ( SYSMETRIC( 9 ) / m.nCharHeight ) + m.nBorderHeight

    DEFINE WINDOW ( m.cWindow )                                             ;
        AT m.nRow,m.nCol                                                    ;
        SIZE m.nHeight,m.nWidth                                             ;
        FONT FNT_name(),FNT_size()                                          ;
        MOVEABLE                                                            ;
        CLOSE                                                               ;
        MINIMIZE                                                            ;
        MAXIMIZE                                                            ;
        RESIZEABLE                                                          ;
        TITLE m.cTitle                                                      ;
        SYSTEM                                                              ;
        COLOR BACKGROUND

    IF ( m.cType == "GENERAL" )

        DEFINE WINDOW wChild                                                ;
            AT - m.nTitleHeight,0                                           ;
            SIZE m.nHeight - 4,m.nWidth                                     ;
            FONT FNT_name(),FNT_size()                                      ;
            TITLE UPPER(ALLTRIM( m.cAlias + "" + m.cField + "GENERAL" )) ;
            COLOR BACKGROUND

        ACTIVATE WINDOW ( m.cWindow ) NOSHOW

        m.nRow = WROWS() - 3
        MODIFY GENERAL ( m.cField ) WINDOW wChild IN WINDOW ( m.cWindow ) NOWAIT

    ELSE                               && MEMO

        DEFINE WINDOW wChild                                                ;
            AT -m.nTitleHeight,-m.nBorderWidth                              ;
            SIZE m.nHeight - 4 - ( m.nBorderHeight * 2),m.nWidth            ;
            FONT FNT_name(),FNT_size()                                      ;
            TITLE m.cAlias + "" + m.cField + "MEMO"                      ;
            RESIZEABLE                                                      ;
            SYSTEM                                                          ;
            COLOR RGB(,,,255,255,255)

        ACTIVATE WINDOW ( m.cWindow ) NOSHOW

        m.nRow = WROWS() - 3
        MODIFY MEMO ( m.cField ) WINDOW wChild IN WINDOW ( m.cWindow ) NOWAIT

    ENDIF

    ACTIVATE WINDOW ( m.cWindow )

    =SCR_relief( "RIGOLE",m.nHeight - 3.7,1,m.nHeight - 0.5,m.nWidth - 1 )

    @ m.nRow,03 SAY "cancel3.bmp" BITMAP
    @ m.nRow,09 SAY "modify3.bmp" BITMAP
    @ m.nRow,15 SAY "create3.bmp" BITMAP

    RELEASE WINDOW wChild

    =TRA_log( OUT_PROGRAM )            && Tracing instruction
    =EVE_start()                       && Restart events polling

RETURN ( .T. )

*----------------------------------------------------------------------------*

FUNCTION MemoClick
    PARAMETERS m.nMouseRow,m.nMouseCol,m.cOnTop

    *-- Ŀ
    *--  PURPOSE : handles mouse click in MEMO window.                
    *-- 

    PRIVATE m.nRows_3
    PRIVATE m.nRows_1

    m.nRows_3 = WROWS() - 3
    m.nRows_1 = WROWS() - 1

    ACTIVATE WINDOW ( WPARENT( m.cOnTop ) )

    IF ( BETWEEN( m.nMouseRow,m.nRows_3,m.nRows_1 ) )

        DO CASE
            CASE BETWEEN( m.nMouseCol,3,08 )

                @ m.nRows_3,03 SAY "cancel4.BMP" BITMAP

                DO WHILE( MOU_isdown() )
                ENDDO

                @ m.nRows_3,03 SAY "cancel3.BMP" BITMAP

                RELEASE WINDOW ( WPARENT( m.cOnTop ) )

            CASE BETWEEN( m.nMouseCol,09,14 )
                IF ( ! EMPTY( memo ) )

                    @ m.nRows_3,09 SAY "modify4.BMP" BITMAP

                    DO WHILE( MOU_isdown() )
                    ENDDO

                    @ m.nRows_3,09 SAY "modify3.BMP" BITMAP

                ENDIF

            CASE BETWEEN( m.nMouseCol,15,21 )

                @ m.nRows_3,15 SAY "CREATE4.BMP" BITMAP

                DO WHILE( MOU_isdown() )
                ENDDO

                @ m.nRows_3,15 SAY "CREATE3.BMP" BITMAP

        ENDCASE

    ENDIF

RETURN ( .T. )

*----------------------------------------------------------------------------*

FUNCTION ARR_search
    PARAMETERS aArray,m.xValue,m.nDim

    *-- Ŀ
    *--  PURPOSE : multi dimension search in an array.                
    *-- 

    PRIVATE m.i
    PRIVATE m.nLength

    m.nLength = ALEN( aArray )
    m.nStep   = ALEN( aArray,2 )

    FOR m.i = m.nDim TO m.nLength STEP m.nStep

        IF ( aArray[m.i] == m.xValue )
            RETU ( CEILING( m.i / m.nStep ) )
        ENDIF

    NEXT

RETURN ( 0 )

*----------------------------------------------------------------------*

FUNCTION ARR_fill
    PARAMETERS aArray,m.xValue

    *-- Ŀ
    *--  PURPOSE : blank an array with the same value.                
    *-- 

    PRIVATE m.i
    PRIVATE m.nLength

    m.nLength = ALEN( aArray )

    FOR m.i = 1 TO m.nLength

        aArray[m.i] = m.xValue

    NEXT

RETURN ( .T. )

*----------------------------------------------------------------------*

FUNCTION CheckFiles
    PARAMETERS m.cSection,m.cINIFile,m.cPath,m.cFile

    *-- Ŀ
    *--  Cette fonction a pour objectif de vrifier qu'un ensemble de  
    *--  fichiers absolument indispensables pour une application sont  
    *--  bel et bien prsents. S'ils ne sont pas prsents, le programme
    *--  renvoie un code d'erreur.                                     
    *-- 

    PRIVATE m.cNeededFiles
    PRIVATE m.i
    PRIVATE m.nTokens
    PRIVATE m.cOldSep
    PRIVATE m.cToken

    m.cNeededFiles = FIL_sectio( m.cSection,m.cINIFile )

    m.cOldSep = STR_setsep( ";" )
    m.nTokens = STR_numtok( m.cNeededFiles )

    FOR m.i = 1 TO m.nTokens

        m.cToken = STR_ntoken( m.i,m.cNeededFiles )

        IF ( ! FILE( m.cPath + m.cToken ) )
            m.cFile = m.cToken
            RETU ( .F. )
        ENDIF
    NEXT

    =STR_setsep( m.cOldSep )

RETURN ( .T. )

*----------------------------------------------------------------------*

PROCEDURE ShowHelp
    PRIVATE m.nHelp

    =EVE_end()

    SET TOPIC TO FIL_reaini( "HELP",ALLTRIM( STR( HLP_code() ) ),VER_ini() )

    HELP

    =EVE_start()

RETURN

*----------------------------------------------------------------------*

FUNCTION MIS_yesno
    PARAMETERS m.nButton,m.cLine1,m.cLine2,m.cLine3

    *-- Ŀ
    *--  PURPOSE : Yes/No dialog box (modal)                          
    *-- 

    PRIVATE m.cWindow
    PRIVATE m.nHeight

    m.nHeight = 11.00

    IF ( EMPTY( m.cLine3 ) )
        m.nHeight = m.nHeight - 1.5
    ENDIF

    IF ( EMPTY( m.cLine2 ) )
        m.nHeight = m.nHeight - 1.5
    ENDIF

    m.cWindow = WIN_mdialg( m.nHeight,54.40         , ;
                            FNT_name(),FNT_size()   , ;
                            "",DALLE )

    ACTIVATE WINDOW ( m.cWindow ) NOSHOW
    MOVE WINDOW ( m.cWindow ) CENTER

    =WIN_grave( 01.00,02.40,m.nHeight - 4,52  )

    @ 00.55,04.00 SAY "Rpondez  la question" STYLE "B"

    @ 02.00,04.00 SAY m.cLine1

    IF ( ! EMPTY( m.cLine2 ) )
        @ 03.50,04.00 SAY m.cLine2
    ENDIF

    IF ( ! EMPTY( m.cLine3 ) )
        @ 05.00,04.00 SAY m.cLine3
    ENDIF

    @ m.nHeight - 3,03.40 GET m.nButton                      ;
                          PICTURE "@*HT \<Oui;\<Non"         ;
                          SIZE 01.75,10.00,1                 ;
                          STYLE "B"

    ACTIVATE WINDOW ( m.cWindow )

    READ CYCLE MODAL

    RELEASE WINDOW ( m.cWindow )

RETURN ( m.nButton )

*----------------------------------------------------------------------*

PROCEDURE PrnDialog
    PRIVATE aPrinters
    PRIVATE cPrnName
    PRIVATE cPrnPort
    PRIVATE aGets
    PRIVATE nWhich
    PRIVATE nButton1
    PRIVATE nButton2
    PRIVATE nButton3
    PRIVATE nDefault
    PRIVATE cPrinters
    PRIVATE cOldSep
    PRIVATE nTokens
    PRIVATE lFromButton
    PRIVATE i

    nWhich      = 1
    nButton1    = 1
    nButton2    = 1
    nButton3    = 1
    nDefault    = 1
    lFromButton = .F.

    =PRN_capa()

    cPrnName  = PRN_name()             && Nom de l'imprimante
    cPrnPort  = PRN_port()             && Port sur lequel elle est installe
    cPrinters = FIL_wsecti( "devices" )&& Toutes les imprimantes installes

    cOldSep   = STR_setsep( ";" )      && Positionnement nouveau sparateur
    nTokens   = STR_numtok( cPrinters )&& Nb de tokens

    DIMENSION aPrinters[nTokens]       && Rserver autant d'lments
    DIMENSION aPrnNames[nTokens]       && Rserver autant d'lments
    DIMENSION aDrivers[nTokens]        && Rserver autant d'lments

    FOR i = 1 TO nTokens               && Extraire chq imprimante
        aPrnNames[i] = STR_ntoken( i,cPrinters )
        aDrivers[i]  = FIL_wreain( "devices",aPrnNames[i] )
        aPrinters[i] = aPrnNames[i]                                      + ;
                       " (" + STR_strtok( 1,aDrivers[i],"," ) + ") sur " + ;
                       STR_strtok( 2,aDrivers[i],"," )
    NEXT

    =STR_setsep( cOldSep )             && Positionner l'ancien sparateur

    DIMENSION aGets[1,4]

    IF ( ! WEXIST( "wPrinters" ) )

        DEFINE WINDOW wPrinters             ;
            AT 0.000, 0.000                 ;
            SIZE 19.40,100.00               ;
            TITLE "Imprimantes"             ;
            FONT FNT_name(),FNT_size()      ;
            FLOAT                           ;
            NOCLOSE                         ;
            NOMINIMIZE                      ;
            SYSTEM                          ;
            COLOR BACKGROUND

        ACTIVATE WINDOW wPrinters NOSHOW
        MOVE WINDOW wPrinters CENTER

        =WIN_grave( 01.00,02.00,03.50,78.00 )
        =WIN_grave( 04.50,02.00,18.00,78.00 )

        @ 01.80,04.00 SAY cPrnName + " sur " + cPrnPort

        @ 00.50,03.80 SAY "Imprimante par dfaut"                       ;
                      FONT FNT_name(),FNT_size()                        ;
                      STYLE "B"

        @ 04.00,03.80 SAY "Imprimantes installes"                      ;
                      FONT FNT_name(),FNT_size()                        ;
                      STYLE "B"

        aGets[1,1] = 5.5
        aGets[1,2] = 4.2
        aGets[1,3] = 09.4
        aGets[1,4] = 72

        DO NiceGet WITH aGets,FNT_name(),FNT_size()

        @ 18.20,02.00 SAY "Changer l'imprimante affectera toutes les applications Windows"

    ELSE

        ACTIVATE WINDOW wPrinters SAME

    ENDIF

    @ 05.50,04.00 GET nWhich                                            ;
                  PICTURE "@&N"                                         ;
                  FROM aPrinters                                        ;
                  SIZE 09.30,71.80                                      ;
                  FONT FNT_name(),FNT_size()                            ;
                  STYLE "B"                                             ;
                  COLOR RGB(,,,255,255,255),RGB(,,,255,255,255)

    @ 15.50,17.00 GET nDefault                                          ;
                  PICTURE "@*HN \!\<Dfinir comme imprimante par dfaut";
                  SIZE 02.00,45.00,00.50                                ;
                  FONT FNT_name(),FNT_size()                            ;
                  STYLE "B"                                             ;
                  VALID SetDefPrn( nWhich )           

    @ 01.00,81.00 GET nButton1                                          ;
                  PICTURE "@*HNT \<Annuler"                             ;
                  SIZE 01.80,16.00,00.30                                ;
                  FONT FNT_name(),FNT_size()                            ;
                  STYLE "B"                                             ;
                  VALID MIS_assign( @lFromButton,.T. )

    @ 03.10,81.00 GET nButton2                                          ;
                  PICTURE "@*HNT \\Fermer"                              ;
                  SIZE 01.80,16.00,00.30                                ;
                  FONT FNT_name(),FNT_size()                            ;
                  STYLE "B"                                             ;
                  VALID MIS_assign( @lFromButton,.T. )

    @ 05.20,81.00 GET nButton3                                          ;
                  PICTURE "@*VN Aide"                                   ;
                  SIZE 01.80,16.00,00.30                                ;
                  FONT FNT_name(),FNT_size()                            ;
                  STYLE "B"

    IF ( ! WVISIBLE( "wPrinters" ) )
        ACTIVATE WINDOW wPrinters
    ENDIF

    READ CYCLE

    IF ( lFromButton )

        RELEASE WINDOW wPrinters

    ENDIF

RETURN

*----------------------------------------------------------------------------*

FUNCTION SetDefPrn
    PARAMETER cPrinter

    =FIL_wwriin( "windows","device",aPrnNames[nWhich] + "," + aDrivers[nWhich] )

    =PRN_capa()

    cPrnName  = PRN_name()             && Nom de l'imprimante
    cPrnPort  = PRN_port()             && Port sur lequel elle est installe

    @ 01.80,04.00 SAY REPLICATE("B",40) COLOR RGB(192,192,192,192,192,192),RGB(192,192,192,192,192,192)
    @ 01.80,04.00 SAY cPrnName + " sur " + cPrnPort

    SHOW GET nButton1 DISABLE
    SHOW GET nButton2 ENABLE

RETURN ( .T. )

*----------------------------------------------------------------------------*

FUNCTION MIS_assign
   PARAMETERS xVar,xValue

   xVar = xValue

RETURN ( .T. )

*----------------------------------------------------------------------*

FUNCTION SetFrom
    PARAMETER m.lVariable,m.lSetting

    *-- Ŀ
    *--  PURPOSE : Sets a value in a variable and returns .T.         
    *-- 

    m.lVariable = m.lSetting

RETURN ( .T. )

*----------------------------------------------------------------------------*

FUNCTION DBF_appblk
    PARAMETER m.nTimes

    PRIVATE m.i

    FOR m.i = 1 TO m.nTimes
        && If Net attention ...
        APPEND BLANK
    NEXT

RETURN ( .T. )

*----------------------------------------------------------------------------*

FUNCTION DBF_delrec

    IF ( DELETED() )
        RECALL
    ELSE
        DELETE
    ENDIF

    GO RECNO()     && Forcing record refresh

RETURN ( .T. )

*----------------------------------------------------------------------------*

FUNCTION ResizeBrowse
    PARAMETERS m.cChild,m.cParent

    *-- Ŀ
    *--  PURPOSE : resizes a BROWSE.                                  
    *-- 

    PRIVATE m.nPos
    PRIVATE m.nMinHeight
    PRIVATE m.nMinWidth
    PRIVATE m.nHeight
    PRIVATE m.nWidth
    PRIVATE m.cFont
    PRIVATE m.nSize
    PRIVATE m.nScrollHSize

    m.nPos = ARR_search( @gaBrowses,UPPER( m.cChild ),1 )

    IF ( m.nPos != 0 )
        m.nMinHeight = VAL( FIL_reaini( gaBrowses[m.nPos,INI_SECTION_CELL], ;
                                        "MinimumHeight"                   , ;
                                        VER_ini()                           ;
                                      )                                     ;
                          )
        m.nMinWidth  = VAL( FIL_reaini( gaBrowses[m.nPos,INI_SECTION_CELL], ;
                                        "MinimumWidth"                    , ;
                                        VER_ini()                           ;
                                      )                                     ;
                          )
    ELSE
        RETU ( .F. )                   && Should exit right away
    ENDIF

    ACTIVATE WINDOW ( m.cParent )

    =EVE_end()                         && Stops event polling

    m.nHeight      = WROWS( m.cParent )
    m.nWidth       = WCOLS( m.cParent )
    m.cFont        = WFONT( 1,m.cParent )
    m.nSize        = WFONT( 2,m.cParent )

    m.nCharHeight  = FONTMETRIC( 1,m.cFont,m.nSize )
    m.nCharWidth   = FONTMETRIC( 6,m.cFont,m.nSize )

    m.nScrollHSize = SYSMETRIC( 8 ) / m.nCharHeight

    IF ( m.nWidth < m.nMinWidth )

        MODIFY WINDOW ( m.cParent )                  ;
              AT WLROW(),WLCOL()                     ;
              SIZE m.nHeight,m.nMinWidth

        m.nWidth = m.nMinWidth

    ENDIF

    IF ( m.nHeight < m.nMinHeight )

        MODIFY WINDOW ( m.cParent )                  ;
              AT WLROW(),WLCOL()                     ;
              SIZE m.nMinHeight,m.nWidth

        m.nHeight = m.nMinHeight

    ENDIF

    IF ( WEXIST( m.cChild ) )

        ZOOM WINDOW ( m.cChild ) NORM ;
             SIZE m.nHeight - 4 + m.nScrollHSize,m.nWidth

    ENDIF

    ACTIVATE WINDOW ( m.cParent ) SAME
    CLEAR

    *-- Draw a border around the buttons
    =SCR_relief( "RIGOLE"                          , ;
                 m.nHeight - 3.7                   , ;
                 1                                 , ;
                 m.nHeight - 0.5                   , ;
                 m.nWidth  - 1 )

    =BrowseButt( gaBrowses[m.nPos,INI_SECTION_CELL] )

    =SCR_relief( "OMBRE",WROWS()-3.1,WCOLS()-23.4,WROWS()-1,WCOLS()-13 )

    @ WROWS() - 3,WCOLS() - 23 SAY "DEB"
    @ WROWS() - 3,WCOLS() - 18 SAY "FIN"

    =Status()

    =EVE_start()                       && Restart event polling

RETURN ( .T. )

*----------------------------------------------------------------------------*

FUNCTION ResizeGeneral
    PARAMETER m.cChild,m.cParent

    *-- Ŀ
    *--  PURPOSE : resizes a GENERAL window.                          
    *-- 

    PRIVATE m.nCharHeight              && Height of a character
    PRIVATE m.nCharWidth               && Width of a character
    PRIVATE m.nTitleHeight             && Height of title
    PRIVATE m.cOldSep                  && Old separator
    PRIVATE m.cAlias                   && Alias of field (MEMO or GENERAL)
    PRIVATE m.cField                   && Field name (MEMO or GENERAL)
    PRIVATE m.nHeight                  && Height of parent window
    PRIVATE m.nWidth                   && Width of parent window
    PRIVATE m.nPos                     && Position in BROWSEs array

    =EVE_end()                         && Stop events polling

    m.nCharHeight  = FONTMETRIC( 1,FNT_name(),FNT_size() )
    m.nCharWidth   = FONTMETRIC( 6,FNT_name(),FNT_size() )

    m.nTitleHeight = SYSMETRIC( 9 ) / m.nCharHeight

    m.cOldSep      = STR_setsep( "" )

    m.cAlias       = STR_ntoken( 1,WTITLE( m.cChild ) )
    m.cField       = STR_ntoken( 2,WTITLE( m.cChild ) )

    =STR_setsep( m.cOldSep )

    ACTIVATE WINDOW ( m.cParent ) SAME
    CLEAR

    m.nHeight = WROWS( m.cParent )
    m.nWidth  = WCOLS( m.cParent )

    && Redefine the MEMO or GENERAL window
    DEFINE WINDOW wChild                                ;
        AT - m.nTitleHeight,0                           ;
        SIZE m.nHeight - 4,m.nWidth                     ;
        FONT FNT_name(),FNT_size()                      ;
        TITLE m.cAlias + "" + m.cField + "GENERAL"   ;
        COLOR RGB(,,,192,192,192)

    m.nRow = WROWS() - 3

    IF ( UPPER( ALLTRIM( ALIAS() ) ) != UPPER( ALLTRIM( m.cAlias ) ) )
        SELECT ( m.cAlias )
    ENDIF

    MODIFY GENERAL ( m.cField ) WINDOW wChild IN WINDOW ( m.cParent ) NOWAIT

    ACTIVATE WINDOW ( m.cParent )

    =SCR_relief( "RIGOLE",m.nHeight - 3.7,1,m.nHeight - 0.5,m.nWidth - 1 )

    @ m.nRow,03 SAY "cancel3.bmp" BITMAP
    @ m.nRow,09 SAY "modify3.bmp" BITMAP
    @ m.nRow,15 SAY "create3.bmp" BITMAP

    RELEASE WINDOW wChild

    =EVE_start()                       && Restart events polling

RETURN ( .T. )

*----------------------------------------------------------------------------*

FUNCTION ResizeMemo
    PARAMETER m.cChild,m.cParent

    *-- Ŀ
    *--  PURPOSE : resizes a MEMO window.                             
    *-- 

    PRIVATE m.nCharHeight              && Height of a character
    PRIVATE m.nCharWidth               && Width of a character
    PRIVATE m.cOldSep                  && Old separator
    PRIVATE m.cAlias                   && Alias of field (MEMO or GENERAL)
    PRIVATE m.cField                   && Field name (MEMO or GENERAL)
    PRIVATE m.nHeight                  && Height of parent window
    PRIVATE m.nWidth                   && Width of parent window
    PRIVATE m.nPos                     && Subscript in BROWSEs array (gaBrowses)
    PRIVATE m.nScrollWidth             && Width of scroll bars
    PRIVATE m.nScrollHeight            && Height of scroll bars
    PRIVATE m.nBorderWidth             && Width of window borders
    PRIVATE m.nBorderHeight            && Height of window borders
    PRIVATE m.cFontNamePa              && Parent window font
    PRIVATE m.nFontSizePa              && Parent window font size
    PRIVATE m.cFontNameCh              && Child window font
    PRIVATE m.nFontSizeCh              && Child window font size
    PRIVATE m.cResizedWin              && Name of window being resized
    PRIVATE m.nRatioX
    PRIVATE m.nRatioY

    =EVE_end()                         && Stop events polling

    m.cResizedWin   = EVE_winres(.T.)  && Title of resized window

    m.cFontNamePa   = WFONT( 1,m.cParent )
    m.nFontSizePa   = WFONT( 2,m.cParent )
    m.cFontNameCh   = WFONT( 1,m.cChild )
    m.nFontSizeCh   = WFONT( 2,m.cChild )

    m.nCharHeight   = FONTMETRIC( 1,m.cFontNameCh,m.nFontSizeCh )
    m.nCharWidth    = FONTMETRIC( 6,m.cFontNameCh,m.nFontSizeCh )

    m.nRatioY       = FONTMETRIC( 1,m.cFontNamePa,m.nFontSizePa ) / ;
                      FONTMETRIC( 1,m.cFontNameCh,m.nFontSizeCh )
    m.nRatioX       = FONTMETRIC( 6,m.cFontNamePa,m.nFontSizePa ) / ;
                      FONTMETRIC( 6,m.cFontNameCh,m.nFontSizeCh )

    m.nBorderHeight = SYSMETRIC( 4 ) / m.nCharHeight
    m.nBorderWidth  = SYSMETRIC( 3 ) / m.nCharWidth
    m.nScrollWidth  = SYSMETRIC( 5 ) / m.nCharWidth
    m.nScrollHeight = SYSMETRIC( 8 ) / m.nCharHeight

    && Save old internal separator and sets a new one
    m.cOldSep       = STR_setsep( "" )

    && Extracts the alias name from the window title
    m.cAlias        = STR_ntoken( 1,WTITLE( m.cChild ) )

    && Extracts the field name from the window title
    m.cField        = STR_ntoken( 2,WTITLE( m.cChild ) )

    =STR_setsep( m.cOldSep )           && Reset internal separator

    ACTIVATE WINDOW ( m.cParent ) SAME && Activate parent window (same state)
    CLEAR                              && Clear it

    m.nHeight = WROWS( m.cParent )     && Determine height of parent window
    m.nWidth  = WCOLS( m.cParent )     && Determine width of parent window

    && Resize child window to follow parent window dimensions

    IF ( "MEMO" $ m.cResizedWin )
        MODIFY WINDOW ( m.cParent )                      ;
              AT WLROW( m.cParent ),WLCOL( m.cParent )   ;
              SIZE ( ( WROWS( m.cChild ) / m.nRatioY ) + ;
                       m.nScrollHeight                 + ;
                       m.nBorderHeight                 + ;
                     4                                   ;
                   )                                   , ;
                   ( WCOLS( m.cChild ) + m.nScrollWidth ) / m.nRatioX

        m.nHeight = WROWS( m.cParent ) && Determine new height of parent window
        m.nWidth  = WCOLS( m.cParent ) && Determine new width of parent window

    ELSE
        ZOOM WINDOW ( m.cChild ) NORM              ;
             SIZE ( ( m.nHeight - 4 ) * m.nRatioY ) + m.nScrollHeight, ;
                    ( m.nWidth * m.nRatioX ) + ( m.nBorderWidth * 2  )

    ENDIF

    m.nRow = WROWS() - 3               && Line where BMPs will be displayed

    SELECT ( m.cAlias )                && Select appropriate work area

    ACTIVATE WINDOW ( m.cParent )      && Activate parent window on top

    =SCR_relief( "RIGOLE",m.nHeight - 3.7,1,m.nHeight - 0.5,m.nWidth - 1 )

    @ m.nRow,03 SAY "cancel3.bmp" BITMAP && Display OK button
    @ m.nRow,09 SAY "modify3.bmp" BITMAP && Display Modify button
    @ m.nRow,15 SAY "create3.bmp" BITMAP && Display Create button

    =EVE_start()                       && Restart events polling

RETURN ( .T. )

*----------------------------------------------------------------------------*

PROCEDURE ErrorHandler
    PARAMETERS m.nErrorCode,m.cDescription,m.cSourceLine,cProc,nSourceLine,m.cCustom

    *-- Ŀ
    *--  PURPOSE : displays information about the error that just     
    *--            occurred. If we can trap error, we'll do it.       
    *--            Otherwise, we simply display the error information 
    *--            and we quit smoothly the application.              
    *-- 

    PRIVATE aError
    PRIVATE aInternals
    PRIVATE aDisplay
    PRIVATE aOS
    PRIVATE aDBF
    PRIVATE aIOs
    PRIVATE aActions

    PRIVATE m.i

    PRIVATE m.nError
    PRIVATE m.nInternals
    PRIVATE m.nExternals
    PRIVATE m.nSystem
    PRIVATE m.nIOs
    PRIVATE m.nDBF
    PRIVATE m.nActions

    PRIVATE m.cText

    PRIVATE m.nAction1
    PRIVATE m.nAction2

    PRIVATE m.cPrnName
    PRIVATE m.cPrnPort


    =TRA_log( IN_PROGRAM )

    IF ( CanTrapError( m.nErrorCode ) )
    ENDIF

    =PRN_capa()

    m.cPrnName  = PRN_name()           && Nom de l'imprimante
    M.cPrnPort  = PRN_port()           && Port sur lequel elle est installe

    m.nError     = 1
    m.nInternals = 1
    m.nExternals = 1
    m.nSystem    = 1
    m.nIOs       = 1
    m.nDBF       = 1
    m.nActions   = 1

    m.cText      = ""

    m.nAction1   = 1
    m.nAction2   = 1

    DIMENSION aError[05]
    DIMENSION aInternals[14]
    DIMENSION aExternals[02]
    DIMENSION aSystem[31]
    DIMENSION aIOs[11]
    DIMENSION aDBF[08]
    DIMENSION aActions[02]

    aExternals[01] = "Vue CONFIG.SYS"
    aExternals[02] = "Vue AUTOEXEC.BAT"

    aActions[01]   = "Vue positions"
    aActions[02]   = "Vue structure DBF"

    aInternals[01] = "Menu mapping :"     + IIF( MEN_mappin(),".T.",".F." )
    aInternals[02] = "Mapping tail :"     + ALLTRIM( STR( MEN_tail() ) )
    aInternals[03] = "Event handler :"    + IIF( EVE_isacti(),".T.",".F." )
    aInternals[04] = "Niveau READ :"      + ALLTRIM(STR(RDLEVEL()))
    aInternals[05] = "Trace :"            + ALLTRIM( TRA_getlog() )
    aInternals[06] = "DDA :"              + ALLTRIM( DDA_getlog() )
    aInternals[07] = "Auteur :"           + VER_author()
    aInternals[08] = "Nom :"              + VER_name()
    aInternals[09] = "Date :"             + VER_date()
    aInternals[10] = "Fichier INI :"      + VER_ini()
    aInternals[11] = "Phase :"
    aInternals[12] = "Dmo :"             + IIF( VER_demo(),"True","False" )
    aInternals[13] = "Version :"          + ALLTRIM(STR(VER_major())) + "." + ALLTRIM(STR(VER_minor()))
    aInternals[14] = "Cargo :"            + VER_cargo()

    aSystem[01]    = "Driver cran :"     + SYS_displa()
    aSystem[02]    = "Dimension cran :"                   + ;
                      ALLTRIM( STR( SCR_cols() ) ) + " x " + ;
                      ALLTRIM( STR( SCR_rows() ) )
    aSystem[03]    = "Country :"            + ALLTRIM( STR( SYS_countr() ) )
    aSystem[04]    = "Processeur :"         + SYS(17)
    aSystem[05]    = "Mode CPU :"           + IIF( SYS_cpumod() == 0, ;
                                                   "Real mode"      , ;
                                                   "Protected mode" )
    aSystem[06]    = "Mmoire disponible :" + SYS(12)
    aSystem[07]    = "Mmoire FoxPro :"     + SYS(1001)
    aSystem[08]    = "Mmoire objets :"     + SYS(1016)
    aSystem[09]    = "Mmoire EMS :"        + SYS(23)
    aSystem[10]    = "Limite EMS :"         + SYS(24)
    aSystem[11]    = "Programme :"          + SYS(16)
    aSystem[12]    = "Resource :"           + SYS(2005)
    aSystem[13]    = "Disques :"            + SYS_dristr()
    aSystem[14]    = "Carte graphique :"    + SYS(2006)
    aSystem[15]    = "DOS :"                + ALLTRIM( STR( SYS_dosmaj() ) ) + ;
                                              "." + ALLTRIM( STR( SYS_dosmin() ) )
    aSystem[16]    = "Windows :"            + ALLTRIM( STR( SYS_winmaj() ) ) + ;
                                              "." + ALLTRIM( STR( SYS_winmin() ) )
    aSystem[17]    = "OS mode :"            + ALLTRIM( STR( SYS_osmode() ) )
    aSystem[18]    = "Modem :"              + IIF( SYS_ismode(),".T.",".F." )
    aSystem[19]    = "Imprimantes :"        + ALLTRIM( STR( SYS_numprn() ) )
    aSystem[20]    = "Courante : "          + m.cPrnName
    aSystem[21]    = "Port :"               + m.cPrnPort
    aSystem[22]    = "Equipement :"         + ALLTRIM( STR( SYS_equip() ) )
    aSystem[23]    = "Mode Video :"         + ALLTRIM( STR( SYS_video() ) )
    aSystem[24]    = "Floppi(es) :"         + ALLTRIM( STR( SYS_numflo() ) )
    aSystem[25]    = "Ports srie :"        + ALLTRIM( STR( SYS_rs232() ) )
    aSystem[26]    = "Adaptateur jeu :"     + IIF( SYS_isgame(),".T.",".F." )
    aSystem[27]    = "Math co-pro :"        + IIF( SYS_ismath(),".T.",".F." )
    aSystem[28]    = "Driver souris :"      + SYS_mouse()
    aSystem[29]    = "Driver rseau :"      + SYS_networ()
    aSystem[30]    = "Prog ID :"            + ALLTRIM( STR( SYS_pgmid() ) )
    aSystem[31]    = "Swap file :"          + SYS_swap()

    aError[01]     = "Code erreur :"        + ALLTRIM( STR( m.nErrorCode ) )
    aError[02]     = "Desc. :"              + m.cDescription
    aError[03]     = "Code :"               + m.cSourceLine
    aError[04]     = "Procdure :"          + m.cProc
    aError[05]     = "Source line :"        + ALLTRIM( STR( m.nSourceLine ) )

    aDBF[01]       = "DBF :"                + ALIAS()
    aDBF[02]       = "Work area :"          + ALLTRIM( STR( SELECT() ) )
    aDBF[03]       = "Index type :"
    aDBF[04]       = "Index expr :"         + SYS( 14,2 )
    aDBF[05]       = "Index order :"        + SYS( 21 )
    aDBF[06]       = "Index name :"         + SYS( 22 )
    aDBF[07]       = "Index filter :"       + SYS( 2021,2 )
    aDBF[08]       = "Tag name :"           &&+ TAG()

    aIOs[01]       = "Win start :"          + SYS_windir()
    aIOs[02]       = "Win system :"         + SYS_sysdir()
    aIOs[03]       = "Lecteur courant :"    + SYS_curdri()
    aIOs[04]       = "Rp. courant :"       + CURDIR()
    aIOs[05]       = "Espace disque :"      + SYS(2020)
    aIOs[06]       = "Espace libre :"       + ALLTRIM( STR( SYS_dskspa( SYS_curdri() ) ))
    aIOs[07]       = "Clusters :"           + ALLTRIM( STR( SYS_totclu( SYS_curdri() ) ))
    aIOs[08]       = "Clusters free :"      + ALLTRIM( STR( SYS_avaclu( SYS_curdri() ) ))
    aIOs[09]       = "Bytes/sector :"       + ALLTRIM( STR( SYS_bytsec( SYS_curdri() ) ))
    aIOs[10]       = "Sector/cluster :"     + ALLTRIM( STR( SYS_secclu( SYS_curdri() ) ))
    aIOs[11]       = "Remote ? :"           + IIF( SYS_isremo(SYS_curdri()),".T.",".F." )

    =EVE_end()                         && Stop events polling
    CLEAR READ ALL

    m.cWindow  = WIN_mdialg( 29,124,FNT_name(),8,"",DALLE )

    MOVE WINDOW ( m.cWindow ) CENTER
    ACTIVATE WINDOW ( m.cWindow ) NOSHOW

    =WIN_grave( 00.70,03.00,09.10, 42.00 )
    =WIN_grave( 00.70,43.00,09.10, 82.00 )
    =WIN_grave( 00.70,83.00,09.10,122.00 )

    @ 00.25,05.00 SAY "Objet erreur"   STYLE "B"
    @ 00.25,45.00 SAY "Etat interne"   STYLE "B"
    @ 00.25,85.00 SAY "Externe"        STYLE "B"

    =WIN_grave( 09.70,03.00,18.10, 42.00 )
    =WIN_grave( 09.70,43.00,18.10, 82.00 )
    =WIN_grave( 09.70,83.00,18.10,122.00 )

    @ 09.20,05.00 SAY "Systeme"        STYLE "B"
    @ 09.20,45.00 SAY "I/O disques"    STYLE "B"
    @ 09.20,85.00 SAY "Databases"      STYLE "B"

    =WIN_grave( 18.70,03.00,27.10, 42.00 )
    =WIN_grave( 18.70,43.00,27.10,101.00 )
    =SCR_relief( "RIGOLE",18.70,103.0,27.10,122.00 )

    @ 18.20,05.00 SAY "Actions"        STYLE "B"
    @ 18.20,45.00 SAY "Mmo"           STYLE "B"

    @ 27.50,03.00 SAY m.cCustom        STYLE "B"

    @ 01.30,04.50 GET m.nError                                      ;
                  PICTURE "@&N"                                     ;
                  FROM aError                                       ;
                  SIZE 7,35.4                                       ;
                  COLOR RGB(,,,255,255,255),RGB(,,,255,255,255)

    @ 01.30,44.50 GET m.nInternals                                  ;
                  PICTURE "@&N"                                     ;
                  FROM aInternals                                   ;
                  SIZE 7,35.4                                       ;
                  COLOR RGB(,,,255,255,255),RGB(,,,255,255,255)

    @ 01.30,84.50 GET m.nExternals                                  ;
                  PICTURE "@&N"                                     ;
                  FROM aExternals                                   ;
                  SIZE 7,35.4                                       ;
                  VALID ShowFile( IIF( m.nExternals == 1          , ;
                                       "C:\CONFIG.SYS"            , ;
                                       "C:\AUTOEXEC.BAT"            ;
                                     )                              ;
                                )                                   ;
                  COLOR RGB(,,,255,255,255),RGB(,,,255,255,255)

    *---------------------------------------------------------------*

    @ 10.30,04.50 GET m.nSystem                                     ;
                  PICTURE "@&N"                                     ;
                  FROM aSystem                                      ;
                  SIZE 7,35.4                                       ;
                  COLOR RGB(,,,255,255,255),RGB(,,,255,255,255)

    @ 10.30,44.50 GET m.nIOs                                        ;
                  PICTURE "@&N"                                     ;
                  FROM aIOs                                         ;
                  SIZE 7,35.4                                       ;
                  COLOR RGB(,,,255,255,255),RGB(,,,255,255,255)

    @ 10.30,84.50 GET m.nDBF                                        ;
                  PICTURE "@&N"                                     ;
                  FROM aDBF                                         ;
                  SIZE 7,35.4                                       ;
                  COLOR RGB(,,,255,255,255),RGB(,,,255,255,255)

    *---------------------------------------------------------------*

    @ 19.30,04.50 GET m.nActions                                    ;
                  PICTURE "@&N"                                     ;
                  FROM aActions                                     ;
                  SIZE 7,35.4                                       ;
                  COLOR RGB(,,,255,255,255),RGB(,,,255,255,255)

    @ 19.30,45.00 EDIT m.cText                                      ;
                  SIZE 07.00,55.00,00.00                            ;
                  SCROLL                                            ;
                  COLOR ,RGB(,,,255,255,255)

    *---------------------------------------------------------------*

    @ 20.50,106.0 GET m.nAction1                  ;
                  PICTURE "@*HT OK"               ;
                  SIZE 02.00,13.00,0              ;
                  STYLE "B"

    @ 23.00,106.0 GET m.nAction2                  ;
                  PICTURE "@*HN Log error"        ;
                  SIZE 02.00,13.00,0              ;
                  STYLE "B"                       ;
                  VALID LogError( m.nErrorCode  , ;
                                  m.cDescription, ;
                                  m.cSourceLine , ;
                                  m.cProc       , ;
                                  m.nSourceLine )

    ACTIVATE WINDOW ( m.cWindow )
    READ CYCLE MODAL

    RELEASE WINDOW ( m.cWindow )

    =TRA_log( OUT_PROGRAM )
    DO eoj WITH "ERROR"

RETURN

*----------------------------------------------------------------------------*

FUNCTION LogError
    PARAMETERS m.nErrorCode,m.cDescription,m.cSourceLine,cProc,nSourceLine

    *-- Ŀ
    *--  PURPOSE : logs error to a logging file.                      
    *-- 

    PRIVATE m.nHandle

    IF ( ! FILE( "ERROR.LOG" ) )
        m.nHandle = FCREATE( "ERROR.LOG" )
    ELSE
        m.nHandle = FOPEN( "ERROR.LOG",12 )
        =FSEEK( m.nHandle,0,2 )
    ENDIF

    IF ( m.nHandle >= 0 )
        =FPUTS( m.nHandle,DTOC(DATE()) + " - " + TIME()                 )
        =FPUTS( m.nHandle,"Error #      :" + LTRIM(STR(m.nErrorCode))   )
        =FPUTS( m.nHandle,"Desciption   :" + m.cDescription             )
        =FPUTS( m.nHandle,"Source code  :" + m.cSourceLine              )
        =FPUTS( m.nHandle,"Source line  :" + LTRIM(STR(m.nSourceLine))  )
        =FPUTS( m.nHandle,"Procedure    :" + m.cProc                    )
        =FPUTS( m.nHandle,"Work area    :" + ALIAS()                    )
        =FPUTS( m.nHandle,"Record       :" + LTRIM(STR(RECNO()))        )
        =FPUTS( m.nHandle,"SET ORDER TO :" + ORDER()                    )
        =FPUTS( m.nHandle,REPLICATE( "-",80 )                           )
        =FFLUSH( m.nHandle )
        =FCLOSE( m.nHandle )
    ENDIF

RETURN ( .T. )

*----------------------------------------------------------------------------*

FUNCTION ShowFile
    PARAMETER m.cFile

    *-- Ŀ
    *--  PURPOSE : shows a file (AUTOEXEC.BAT or CONFIG.SYS, etc.)    
    *-- 

    PRIVATE m.cText
    PRIVATE m.nAction
    PRIVATE m.nHandle
    PRIVATE m.cLine

    m.nAction = 1
    m.cText   = ""
    m.nHandle = FOPEN( m.cFile )

    IF ( m.nHandle != -1 )

        DO WHILE ( ! FEOF( m.nHandle ) )
            m.cText = m.cText + FGETS( m.nHandle,254 ) + CHR(13)+CHR(10)
        ENDDO

        =FCLOSE( m.nHandle )

        m.cWindow = WIN_mdialg( 23.00,102.20,FNT_name(),FNT_size(),"View file",DALLE )

        ACTIVATE WINDOW ( m.cWindow ) NOSHOW

        =WIN_grave( 01.00,02.40,06.00,88  )
        =WIN_grave( 01.00,90.00,06.00,100 )

        @ 02.70,92.00 SAY "BUG.BMP" BITMAP

        @ 01.50,03.50 SAY "Viewing " + m.cFile STYLE "B"
        @ 03.00,03.50 SAY "Reading mode"
        @ 04.50,03.50 SAY "Handle : " + ALLTRIM( STR( m.nHandle ) )

        @ 06.50,02.80 EDIT m.cText              ;
                      SIZE 10.50,97.20,00.00    ;
                      SCROLL                    ;
                      COLOR ,RGB( ,,,255,255,255 )

        =SCR_relief( "RIGOLE",17.50,02.40,22,100 )

        @ 18.50,4 GET m.nAction PICTURE "@*BHT ok2.bmp" SIZE 2.5,12,0

        MOVE WINDOW ( m.cWindow ) CENTER
        ACTIVATE WINDOW ( m.cWindow )

        READ CYCLE MODAL

        RELEASE WINDOW ( m.cWindow )

    ENDIF

RETURN ( .T. )

*----------------------------------------------------------------------------*

FUNCTION ResizeDesktop

    *-- Ŀ
    *--  PURPOSE : resizes desktop.                                   
    *-- 

    PRIVATE m.cLastWin
    PRIVATE m.cImage

    =TRA_log( IN_PROGRAM )             && Tracing instruction

    ACTIVATE SCREEN
    CLEAR

    m.cImage = DSK_center()

    IF ( ! EMPTY( m.cImage ) )
        @ 0,0 SAY m.cImage BITMAP CENTER
    ENDIF

    m.cLastWin = WLAST()

    && If desktop is maximized, store this state
    =DSK_maximi( WMAXIMUM( "SCREEN" ) )

    IF ( ! EMPTY( m.cLastWin ) )
        ACTIVATE WINDOW ( m.cLastWin )
    ENDIF

    =TRA_log( OUT_PROGRAM )            && Tracing instruction

RETURN ( .T. )

*----------------------------------------------------------------------------*

FUNCTION OuiNon

    IF ( PATIENTS.INVO_MED )
        IF ( EMPTY( PATINO ) )
            RETU ( " " )
        ELSE
            RETU ( "Oui" )
        ENDIF
    ELSE
        IF ( EMPTY( PATINO ) )
            RETU ( " " )
        ELSE
            RETU ( "Non" )
        ENDIF
    ENDIF

RETURN ( "xxx" )

*----------------------------------------------------------------------------*

FUNCTION OuiNon2

    IF ( PATIENTS.INVO_ACT )
        IF ( EMPTY( PATINO ) )
            RETU ( " " )
        ELSE
            RETU ( "Oui" )
        ENDIF
    ELSE
        IF ( EMPTY( PATINO ) )
            RETU ( " " )
        ELSE
            RETU ( "Non" )
        ENDIF
    ENDIF

RETURN ( "xxx" )

*----------------------------------------------------------------------------*

FUNCTION TIM_add
    PARAMETERS m.cTime1,m.cTime2,m.cSign

    PRIVATE m.cTime

    PRIVATE m.nHours1
    PRIVATE m.nMinutes1
    PRIVATE m.nSeconds1

    PRIVATE m.nHours2
    PRIVATE m.nMinutes2
    PRIVATE m.nSeconds2

    PRIVATE m.nHours
    PRIVATE m.nMinutes
    PRIVATE m.nSeconds

    PRIVATE m.nTimes

    m.nHours1   = VAL( LEFT(   m.cTime1  ,2 ) )
    m.nMinutes1 = VAL( SUBSTR( m.cTime1,4,2 ) )
    m.nSeconds1 = VAL( RIGHT(  m.cTime1  ,2 ) )

    m.nHours2   = VAL( LEFT(   m.cTime2  ,2 ) )
    m.nMinutes2 = VAL( SUBSTR( m.cTime2,4,2 ) )
    m.nSeconds2 = VAL( RIGHT(  m.cTime2  ,2 ) )

    DO CASE
        CASE ( m.cSign == "+" )
            m.nSeconds = m.nSeconds1 + m.nSeconds2

            m.nTimes   = INT( m.nSeconds / 60 )

            m.nSeconds = m.nSeconds % 60

            m.nMinutes = m.nMinutes1 + m.nMinutes2 + m.nTimes

            m.nTimes   = INT( m.nMinutes / 60 )

            m.nMinutes = m.nMinutes % 60

            m.nHours   = ( m.nHours1 + m.nHours2 + m.nTimes ) % 24

            m.cTime    = PADL( ALLTRIM(STR(m.nHours  )),2,"0" ) + ":" + ;
                         PADL( ALLTRIM(STR(m.nMinutes)),2,"0" ) + ":" + ;
                         PADL( ALLTRIM(STR(m.nSeconds)),2,"0" )

        CASE ( m.cSign == "-" )
            IF ( m.nSeconds == 0 )
                m.nSeconds = 60
            ENDIF

            IF ( m.nMinutes == 0 )
                m.nMinutes = 60
            ENDIF

            m.nSeconds = m.nSeconds1 - m.nSeconds2

            m.nMinutes = m.nMinutes1 - m.nMinutes2
            m.nHours   = m.nHours1   - m.nHours2

        OTHERWISE
            m.cTime = "xx:xx:xx"

    ENDCASE

RETURN ( m.cTime )

*----------------------------------------------------------------------------*

FUNCTION WhichBr
    PRIVATE m.cBrowseEntries
    PRIVATE m.nBrowses
    PRIVATE m.i
    PRIVATE m.cOldSep
    PRIVATE m.cSection
    PRIVATE m.cSec
    PRIVATE m.cDesc

    PRIVATE m.nAction
    PRIVATE m.nWhich

    m.nAction = 1
    m.nWhich  = 1

    m.cBrowseEntries = FIL_sectio( "BROWSES",VER_ini() )
    m.cOldSep        = STR_setsep( ";" )
    m.nBrowses       = STR_numtok( m.cBrowseEntries )

    DIMENSION aBrowses[m.nBrowses]
    DIMENSION aBrSec[m.nBrowses]

    FOR m.i = 1 TO m.nBrowses
        m.cSection    = STR_ntoken( m.i,m.cBrowseEntries )
        m.cBrowseDef  = FIL_reaini( "BROWSES",m.cSection,VER_ini() )

        =STR_setsep( "," )

        m.cDesc = STR_ntoken( 4,m.cBrowseDef )
        m.cSec  = STR_ntoken( 2,m.cBrowseDef )

        aBrSec[m.i] = m.cSec

        IF ( EMPTY( m.cDesc ) .OR. LEFT( m.cDesc,1 ) == "?" )
            aBrowses[m.i] = m.cSec
        ELSE
            aBrowses[m.i] = m.cDesc
        ENDIF

        =STR_setsep( ";" )

    NEXT

    =STR_setsep( m.cOldSep )

    DEFINE WINDOW wChooseBr                             ;
        AT 00,00                                        ;
        SIZE 13,50                                      ;
        TITLE "Choose a browse"                         ;
        FONT FNT_name(),FNT_size()                      ;
        NOCLOSE                                         ;
        SYSTEM                                          ;
        FLOAT                                           ;
        GROW                                            ;
        COLOR LIGHT_GRAY

    MOVE WINDOW wChooseBr CENTER
    ACTIVATE WINDOW wChooseBr NOSHOW

    =WIN_grave( 01.00,33.00,12.00,49.00  )

    @ 01.00,02.00 GET m.nWhich                          ;
                  FROM aBrowses                         ;
                  PICTURE "@&T"                         ;
                  FONT FNT_name(),FNT_size()            ;
                  SIZE 11.00,30.00                      ;
                  VALID MIS_assign( @m.nAction,1 )

    @ 02.00,35.00 GET m.nAction                         ;
                  PICTURE "@*BVT ok2.bmp;cancel.bmp"    ;
                  FONT FNT_name(),FNT_size()            ;
                  SIZE 2.3,12,0.5

    ACTIVATE WINDOW wChooseBr

    READ CYCLE MODAL

    RELEASE WINDOW wChooseBr

    IF ( m.nAction == 1 )

        =BrBuild( aBrSec[m.nWhich],VER_ini() )

    ENDIF

RETURN ( .T. )

*----------------------------------------------------------------------------*

FUNCTION BrBuild
    PARAMETER m.cSection,m.cIniFile

    *-- Ŀ
    *--  PURPOSE : Changes BROWSE settings                            
    *-- 

    PRIVATE m.nDefault
    PRIVATE m.nAction
    PRIVATE m.cLine
    PRIVATE m.cWindow
    PRIVATE m.cSection
    PRIVATE m.nHelpCode
    PRIVATE m.lCanMove
    PRIVATE m.lCanGrow
    PRIVATE m.cTitle
    PRIVATE m.cFiller
    PRIVATE m.cButtons1
    PRIVATE m.cButtons2
    PRIVATE m.cButtons3
    PRIVATE m.nRow
    PRIVATE m.nCol
    PRIVATE m.nHeight
    PRIVATE m.nWidth
    PRIVATE m.nMinHeight
    PRIVATE m.nMinWidth
    PRIVATE m.cStyle
    PRIVATE m.cColor
    PRIVATE m.cFields1
    PRIVATE m.cFields2
    PRIVATE m.cFields3
    PRIVATE m.cMode
    PRIVATE m.lRelation
    PRIVATE m.cWhenBlock
    PRIVATE m.cPostBrowse

    m.nAction     = 1
    m.nDefault    = 1
    m.nSearchBMP  = 1
    m.lCanMove    =      FIL_reaini( m.cSection,"CanMove"      ,m.cIniFile ) == "ON"
    m.lCanGrow    =      FIL_reaini( m.cSection,"CanGrow"      ,m.cIniFile ) == "ON"
    m.nHelpCode   = VAL( FIL_reaini( m.cSection,"HelpCode"     ,m.cIniFile ) )
    m.cTitle      =      FIL_reaini( m.cSection,"WindowTitle"  ,m.cIniFile )
    m.cFiller     =      FIL_reaini( m.cSection,"Filler"       ,m.cIniFile )
    m.cButtons1   = PADR(FIL_reaini( m.cSection,"Buttons1"     ,m.cIniFile ),150)
    m.cButtons2   = PADR(FIL_reaini( m.cSection,"Buttons2"     ,m.cIniFile ),150)
    m.cButtons3   = PADR(FIL_reaini( m.cSection,"Buttons3"     ,m.cIniFile ),150)
    m.nRow        = VAL( FIL_reaini( m.cSection,"Row"          ,m.cIniFile ) )
    m.nCol        = VAL( FIL_reaini( m.cSection,"Col"          ,m.cIniFile ) )
    m.nHeight     = VAL( FIL_reaini( m.cSection,"Height"       ,m.cIniFile ) )
    m.nWidth      = VAL( FIL_reaini( m.cSection,"Width"        ,m.cIniFile ) )
    m.nMinHeight  = VAL( FIL_reaini( m.cSection,"MinimumHeight",m.cIniFile ) )
    m.nMinWidth   = VAL( FIL_reaini( m.cSection,"MinimumWidth" ,m.cIniFile ) )
    m.cStyle      =      FIL_reaini( m.cSection,"Style"        ,m.cIniFile )
    m.cColor      =      FIL_reaini( m.cSection,"Color"        ,m.cIniFile )
    m.cFields1    = PADR(FIL_reaini( m.cSection,"Fields1"      ,m.cIniFile ),150)
    m.cFields2    = PADR(FIL_reaini( m.cSection,"Fields2"      ,m.cIniFile ),150)
    m.cFields3    = PADR(FIL_reaini( m.cSection,"Fields3"      ,m.cIniFile ),150)
    m.cMode       =      FIL_reaini( m.cSection,"Mode"         ,m.cIniFile )
    m.lRelation   =      FIL_reaini( m.cSection,"Relation"     ,m.cIniFile ) == "ON"
    m.cWhenBlock  =      FIL_reaini( m.cSection,"WhenBlock"    ,m.cIniFile )
    m.cPostBrowse =      FIL_reaini( m.cSection,"PostBrowse"   ,m.cIniFile )

    m.cButtons1   = STRTRAN( m.cButtons1,"","~" )
    m.cButtons1   = STRTRAN( m.cButtons1,"","" )
    m.cButtons2   = STRTRAN( m.cButtons2,"","~" )
    m.cButtons2   = STRTRAN( m.cButtons2,"","" )
    m.cButtons3   = STRTRAN( m.cButtons3,"","~" )
    m.cButtons3   = STRTRAN( m.cButtons3,"","" )

    m.cWindow = WIN_mdialg( 25.00,105.20,FNT_name(),FNT_size(),"Browse Constructor",DALLE )

    ACTIVATE WINDOW ( m.cWindow ) NOSHOW

    =WIN_grave( 01.00,02.40,WROWS()-4.5,103.00  )
    =WIN_grave( 10.00,03.50,14.50    ,101.90  )

    @ 00.50,03.50 SAY UPPER( m.cIniFile ) + " : " + m.cSection STYLE "B"
    @ 09.50,04.60 SAY "Dimensions " STYLE "B"

    @ 02.00,45.00 SAY "Color"
    @ 02.00,74.00 SAY "Help code"
    @ 03.50,03.50 SAY "Window title"
    @ 03.50,49.00 SAY "Filler file"
    @ 05.00,03.50 SAY "Buttons #1"
    @ 06.50,03.50 SAY "Buttons #2"
    @ 08.00,03.50 SAY "Buttons #3"
    @ 11.00,04.60 SAY "Row"
    @ 10.70,21.00 SAY "ROW.BMP"      BITMAP STYLE "T"
    @ 11.00,28.00 SAY "Col"
    @ 10.70,43.40 SAY "COL.BMP"      BITMAP STYLE "T"
    @ 11.00,50.40 SAY "Height"
    @ 10.70,68.50 SAY "HEIGHT.BMP"   BITMAP STYLE "T"
    @ 11.00,74.60 SAY "Width"
    @ 10.70,95.30 SAY "WIDTH.BMP"    BITMAP STYLE "T"
    @ 13.00,04.60 SAY "Minimum height"
    @ 12.70,35.00 SAY "MINHEIGH.BMP" BITMAP STYLE "T"
    @ 13.00,42.00 SAY "Minimum width"
    @ 12.70,71.00 SAY "MINWIDTH.BMP" BITMAP STYLE "T"

    @ 15.50,03.50 SAY "Fields #1"
    @ 17.00,03.50 SAY "Fields #2"
    @ 18.50,03.50 SAY "Fields #3"

    @ 02.00,03.50 GET m.lCanMove   SIZE 01.00,01.00 STYLE "T" PICTURE "@*C Move Window ?"
    @ 02.00,25.00 GET m.lCanGrow   SIZE 01.00,01.00 STYLE "T" PICTURE "@*C Grow Window ?"
    @ 02.00,52.00 GET m.cColor     SIZE 01.00,20.00 COLOR SCHEME 19
    @ 02.00,85.00 GET m.nHelpCode  SIZE 01.00,10.00 COLOR SCHEME 19
    @ 03.50,17.00 GET m.cTitle     SIZE 01.00,30.00 COLOR SCHEME 19
    @ 03.50,59.00 GET m.cFiller    SIZE 01.00,30.00 COLOR SCHEME 19
    @ 03.30,91.00 GET m.nSearchBMP            ;
                  PICTURE "@*BHN findcpt.bmp" ;
                  SIZE 01.40,03.50,00.80      ;
                  FONT FNT_name(),FNT_size()  ;
                  VALID LookBmp( @m.cFiller )
    @ 05.00,17.00 GET m.cButtons1  SIZE 01.00,84.00 COLOR SCHEME 19
    @ 06.50,17.00 GET m.cButtons2  SIZE 01.00,84.00 COLOR SCHEME 19
    @ 08.00,17.00 GET m.cButtons3  SIZE 01.00,84.00 COLOR SCHEME 19
    @ 11.00,10.00 GET m.nRow       SIZE 01.00,10.00 COLOR SCHEME 19
    @ 11.00,32.40 GET m.nCol       SIZE 01.00,10.00 COLOR SCHEME 19
    @ 11.00,58.00 GET m.nHeight    SIZE 01.00,10.00 COLOR SCHEME 19
    @ 11.00,82.00 GET m.nWidth     SIZE 01.00,12.00 COLOR SCHEME 19
    @ 13.00,22.00 GET m.nMinHeight SIZE 01.00,12.00 COLOR SCHEME 19
    @ 13.00,58.00 GET m.nMinWidth  SIZE 01.00,12.00 COLOR SCHEME 19

    @ 15.50,17.00 GET m.cFields1   SIZE 01.00,84.00 COLOR SCHEME 19
    @ 17.00,17.00 GET m.cFields2   SIZE 01.00,84.00 COLOR SCHEME 19
    @ 18.50,17.00 GET m.cFields3   SIZE 01.00,84.00 COLOR SCHEME 19

    =SCR_relief( "RIGOLE",WROWS()-4,02.40,WROWS()-0.7,WCOLS()-2.4 )

    @ WROWS()-3.5,04 GET m.nAction  PICTURE "@*BHT ok2.bmp;cancel.bmp" SIZE 2.3,12,2
    @ WROWS()-3.5,32 GET m.nDefault             ;
                     PICTURE "@*HN Default"     ;
                     SIZE 2.3,12,2              ;
                     FONT FNT_name(),FNT_size() ;
                     STYLE "B"                  ;
                     VALID SetDef( m.cSection,m.cIniFile )

    MOVE WINDOW ( m.cWindow ) CENTER
    ACTIVATE WINDOW ( m.cWindow )

    READ CYCLE MODAL

    RELEASE WINDOW ( m.cWindow )

    IF ( m.nAction == 1 )
        m.cButtons1 = STRTRAN( m.cButtons1,"~","" )
        m.cButtons1 = STRTRAN( m.cButtons1,"","" )
        m.cButtons2 = STRTRAN( m.cButtons2,"~","" )
        m.cButtons2 = STRTRAN( m.cButtons2,"","" )
        m.cButtons3 = STRTRAN( m.cButtons3,"~","" )
        m.cButtons3 = STRTRAN( m.cButtons3,"","" )

        =FIL_wriini( m.cSection,"CanMove"      ,IIF(m.lCanMove,"ON","OFF"),m.cIniFile )
        =FIL_wriini( m.cSection,"CanGrow"      ,IIF(m.lCanGrow,"ON","OFF"),m.cIniFile )
        =FIL_wriini( m.cSection,"WindowTitle"  ,m.cTitle,m.cIniFile )
        =FIL_wriini( m.cSection,"Color"        ,m.cColor   ,m.cIniFile )

        =FIL_wriini( m.cSection,"Buttons1"     ,m.cButtons1,m.cIniFile )
        =FIL_wriini( m.cSection,"Buttons2"     ,m.cButtons2,m.cIniFile )
        =FIL_wriini( m.cSection,"Buttons3"     ,m.cButtons3,m.cIniFile )

        =FIL_wriini( m.cSection,"Row"          ,ALLTRIM(STR(m.nRow      )),m.cIniFile )
        =FIL_wriini( m.cSection,"Row"          ,ALLTRIM(STR(m.nCol      )),m.cIniFile )
        =FIL_wriini( m.cSection,"Height"       ,ALLTRIM(STR(m.nHeight   )),m.cIniFile )
        =FIL_wriini( m.cSection,"Width"        ,ALLTRIM(STR(m.nWidth    )),m.cIniFile )
        =FIL_wriini( m.cSection,"MinimumHeight",ALLTRIM(STR(m.nMinHeight)),m.cIniFile )
        =FIL_wriini( m.cSection,"MinimumWidth" ,ALLTRIM(STR(m.nMinWidth )),m.cIniFile )

        =FIL_wriini( m.cSection,"Fields1"      ,m.cFields1,m.cIniFile )
        =FIL_wriini( m.cSection,"Fields2"      ,m.cFields2,m.cIniFile )
        =FIL_wriini( m.cSection,"Fields3"      ,m.cFields3,m.cIniFile )

        =FIL_wriini( m.cSection,"Filler"       ,m.cFiller  ,m.cIniFile )

    ENDIF

RETURN ( m.nAction == 1 )

*----------------------------------------------------------------------------*

FUNCTION SetDef
    PARAMETERS m.cSection,m.cIniFile

    m.cButtons1 = PADR(FIL_reaini( m.cSection,"OriButtons1",m.cIniFile ),150)
    m.cButtons2 = PADR(FIL_reaini( m.cSection,"OriButtons2",m.cIniFile ),150)
    m.cButtons3 = PADR(FIL_reaini( m.cSection,"OriButtons3",m.cIniFile ),150)
    m.cFields1  = PADR(FIL_reaini( m.cSection,"OriFields1" ,m.cIniFile ),150)
    m.cFields2  = PADR(FIL_reaini( m.cSection,"OriFields2" ,m.cIniFile ),150)
    m.cFields3  = PADR(FIL_reaini( m.cSection,"OriFields3" ,m.cIniFile ),150)

    m.cButtons1  = STRTRAN( m.cButtons1,"","~" )
    m.cButtons1  = STRTRAN( m.cButtons1,"","" )
    m.cButtons2  = STRTRAN( m.cButtons2,"","~" )
    m.cButtons2  = STRTRAN( m.cButtons2,"","" )
    m.cButtons3  = STRTRAN( m.cButtons3,"","~" )
    m.cButtons3  = STRTRAN( m.cButtons3,"","" )

    SHOW GET m.cButtons1
    SHOW GET m.cButtons2
    SHOW GET m.cButtons3
    SHOW GET m.cFields1 
    SHOW GET m.cFields2 
    SHOW GET m.cFields3 

RETURN ( .T. )

*----------------------------------------------------------------------------*

FUNCTION LookBMP
    PARAMETER m.cGet

    PRIVATE m.lIsEvent
    PRIVATE m.cBMP

    m.lIsEvent = EVE_isacti()

    IF ( m.lIsEvent )
        =EVE_end()
    ENDIF

    *-- Ask the user to select a BMP file
    m.cBMP = GETFILE( "BMP","Filler BMP","Open",0 )

    IF ( ! EMPTY( m.cBMP ) )
        m.cGet = m.cBMP
    ENDIF

    SHOW GET m.cFiller

    IF ( m.lIsEvent )
        =EVE_start()
    ENDIF

RETURN ( .T. )
